/* --------------------------------------------------------------
          ( 2.2).
       - .

    http://www.imach.uran.ru/cbignum

    Copyright 1999-2024, ..,   PAH.
    All Rights Reserved.

         "public domain",
    ..   ,  
         
          .

        " "
     - ,   . 
           . 
          , ,
            
       .
-------------------------------------------------------------- */
#ifndef _CBIGNUMF_INL
#define _CBIGNUMF_INL

#ifndef _CBIGNUMF_H
#include "Cbignumf.h"
#endif//_CBIGNUMF_H

#include <assert.h>
#include <limits.h>
#include <stdlib.h>
#define DISALLOW_EXARRAY_SHORTTYPE
#include "Cbignum.h"
#define BITS    (CHAR_BIT * sizeof (CBNL))
#define LBITS   (CHAR_BIT * sizeof (long))

#ifndef NDEBUG
cTTY cPrg (cBigNumberProgress);
#define CPRG(a) cPrg<<a
#else //NDEBUG
#define CPRG(a)
#endif//NDEBUG

#ifdef  _MSC_VER
#pragma auto_inline (off)
#endif/*_MSC_VER*/

static int count_floor2nBITS()
{
  int n = 2; while (n <= (BITS-1)/2) n <<= 1;
  return (n);
}
static int floor2nBITS = count_floor2nBITS();
static int floor2nBITSm1 = floor2nBITS - 1;

//================================================
//          CBNL.
//================================================

#ifdef  __cplusplus
extern "C" {
#endif//__cplusplus

//              ,
//                
//      . ,  0  -1   , 1  -2 
//      1  ,  127  -128  7  .
//         n     2 
//       n.

int    _CBNL_C  cLongBits (CBNL num)            //   
{                                               //   0..BITS-1.
  num ^= (num >> (BITS-1));                     //  .
#ifdef  _ubsrCBNL
  unsigned long n;
  return (_ubsrCBNL (&n, num)? (int)n + 1: 0);
#else //_ubsrCBNL
  int n = 0;
  int k = floor2nBITSm1;                        //  ..31,15,7,3,1.
  do
  {
    int k0 = (((num >> k) == 0) - 1) & (k + 1); num >>= k0; n += k0;
  }
  while ((k >>= 1) != 0);
  return (n += (num > 0));                      //  0.
#endif//_ubsrCBNL
}

//              ,
//        0        .

int    _CBNL_C  cULongBits (unsigned CBNL num)  //   
{                                               //   0..BITS.
#ifdef  _ubsrCBNL
  unsigned long n;
  return (_ubsrCBNL (&n, num)? (int)n + 1: 0);
#else //_ubsrCBNL
  int n = (((CBNL)num >= 0) - 1); num &= ~n;
      n &= BITS;                                // BITS  .
  int k = floor2nBITSm1;                        //  ..31,15,7,3,1.
  do
  {
    int k0 = (((num >> k) == 0) - 1) & (k + 1); num >>= k0; n += k0;
  }
  while ((k >>= 1) != 0);
  return (n += (num > 0));                      //  0.
#endif//_ubsrCBNL
}

//        0-    ,
//            .
//      ,  0      0-,
//      2  -2  1  , 128  -128 
//      7  0-.    n 
//      0-   2   n.

int    _CBNL_C  cLongExBits (CBNL num)          //   0-
{                                               //   0..BITS-1.
#ifdef  _ubsfCBNL
  unsigned long n;
  return (_ubsfCBNL (&n, num)? (int)n: 0);
#else //_ubsfCBNL
  int n = 0;
  if (num) while ((num & (CBNL)1) == 0) { ++n; num >>= 1; }
  return (n);
#endif //_ubsfCBNL
}

//            2   n.

int    _CBNL_C  cLongExactLog2 (CBNL num)       //  log2  -1.
{                                               // log2   0..BITS-1.
  int n = cLongExBits (num);
  if ((num >> n) != 1) n = -1;
  return n;
}

//       CBNL    .

#ifdef CBNL_LONG_LONG                           // Inline  CBNL long.
unsigned CBNL _CBNL_C cLongRandom (             //  .
                unsigned long (*pfnRand)()      //   .
)                                               //   .
{
  unsigned CBNL lRand = (*pfnRand)();
  int sh = LBITS;
  do lRand |= ((CBNL)(*pfnRand)() << sh);
  while ((sh += LBITS) < BITS);
  return (lRand);
}
#endif//CBNL_LONG_LONG

#ifdef  __cplusplus
}
#endif//__cplusplus

//================================================
//          cBigNumber.
//================================================
//             CBNL.
//             CBNL-,
//           
//        ,   
//              
//      .      .
//
//            C.
//            
//           ;  
//             size_t.
//            ;
//        inline-,  
//          .
//
//           EXPTR(CBNL)
//       CBPTR(CBNL),    const.
//         CBNL*     exptr<CBNL>
//              
//      .
//
//         
//        :
//      NDEBUG    -    
//                       
//                     .
//      NCHECKPTR -    
//                    ;  
//                      
//                     _CBIGNUM_NCHECKPTR.
//
//        ,  "C", 
//        .
//          
//         .
//          
//       ,   
//          
//        , 
//      EXPTR(CBNL)  CBPTR(CBNL)  CBNL*.

#ifdef  NCHECKPTR
#ifdef  __cplusplus
extern "C" {
#endif//__cplusplus
#endif//NCHECKPTR

//================================================
//       .
//================================================

//           
//          .   
//           ,
//            .
//          .

void    cBigNumberDump (                        //    .
                const   CBPTR(CBNL) p1          //  .
        )
{
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .
  for (; n1; n1--) cBigNumberMessages <<" "<< (const char*) cHexDump (p1 [n1]);
  cBigNumberMessages << "\n";
}

//            
//           .
//      the high word followed by total number of words.

void    cBigNumberInfo (                        //  ( ).
                const   CBPTR(CBNL) p1          //  .
        )
{
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .
  cBigNumberMessages << cHexDump (p1 [n1]);
  if (n1 > 1)
    cBigNumberMessages << "... (" << (CBNL)(n1 * sizeof (CBNL)) << " bytes)\n";
}

void    cBigNumberERange  (                     //   .
                const   CBPTR(CBNL) p1          //  .
        )
{
  cBigNumberMessages << "cBigNumber value out of range: ";
  cBigNumberInfo (p1);
  abort();
}

//================================================
//       .
//================================================

//          ,  
//               
//          .

size_t  cBigNumberWords (                       //   .
                const   CBPTR(CBNL) p1          //  .
        )                                       // , .
{
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .
  if (n1)
  {
    CBNL sign = p1 [n1] >> (BITS-1);            //  0  -1.
    do
    {
      if (p1 [n1] != sign) break;               //   ?
    }
    while (--n1 != 0);
  }
  return (n1);
}

//           .
//         > CBNL_MAX  cBigNumberERange().

CBNL    cBigNumberBits (                        //   .
                const   CBPTR(CBNL) p1          //  .
        )                                       // , .

{
  size_t n = cBigNumberWords(p1);               //   .
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .
  if (n)
  {                                             //  .
    if ((CBNL)n > (CBNL)(CBNL_MAX / BITS))
       cBigNumberERange (p1);
    return ((CBNL)(n - 1) * BITS + cULongBits ((unsigned CBNL)
                                    (p1 [n] ^ (p1 [n1] >> (BITS-1)))));
  }
  return (0);
}

//        0-    ,
//            .
//         ,   0- .

size_t  cBigNumberExWords (                     //   0-.
                const   CBPTR(CBNL) p1          //  .
)                                               // , .
{
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .
  for (size_t n = 0; n < n1; n++)
  {
    if (p1 [n + 1] != 0) return (n);            //  0-.
  }
  return (0);
}

//        0-   .
//          > CBNL_MAX  cBigNumberERange().

CBNL    cBigNumberExBits (                      //   0-.
                const   CBPTR(CBNL) p1          //  .
        )                                       // , .

{
  size_t n = cBigNumberExWords(p1);             //   0-.
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .
  if (n1)
  {                                             //  .
    if ((CBNL)n > (CBNL)((CBNL_MAX - (BITS - 1)) / BITS))
      cBigNumberERange (p1);
    return ((CBNL)n * BITS + cLongExBits (p1 [n + 1]));
  }
  return (0);
}

//================================================
//        .
//================================================

//        ,    
//           CBNL-,  
//        :
//      -     1,     
//             ;
//      -     .

size_t _CBNL_C  cBigNumberIsFit (               //  .
                const   CBPTR(CBNL) p1          //  .
        )                                       //   ,
{                                               //   1  0.
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .

  if (n1 > 1) return ((p1 [n1] != (p1 [n1 - 1] >> (BITS-1))));

  return (n1);                                  //   1  0.
}

//          ,
//          (  1).

size_t _CBNL_C _cBigNumberFit (                 // .
                        EXPTR(CBNL) p1          //   .
        )                                       //   >= 2.
{
  size_t n1 = (size_t)(*p1);                    //  .
  p1 += n1;                                     //  .

  if (n1)                                       //      
  {                                             //   
    CBNL pass, lp = *p1--;                      //   0   1, 
    do continue;                                //   .
    while (--n1 != 0 &&
        (pass = lp, lp = *p1--, pass == (lp >> (BITS-1))));
  }                                             //     ,
  else { p1 [1] = 0; }                          //   .

  return (n1 + 1);                              //  .
}
//#define cBigNumberFit(p1)     (size_t)(*(p1)=_cBigNumberFit(p1))

//            
//      .      
//       ,      1.
//
//          .

size_t _CBNL_C _cBigNumberFitTo (               // .
                        EXPTR(CBNL) p1,         //   .
                        size_t      n           //  .
        )                                       //    
{                                               // max (*p1 + 2, n + 1).
  size_t n1 = (size_t)(*p1);                    //  .
  CBNL pass = p1 [n1] >> (BITS-1);              // .

  do
    p1 [++n1] = pass;                           //  .
  while (n1 < n);

  return (n1);                                  //  .
}
//#define cBigNumberFitTo(p1,n) (size_t)(*(p1)=_cBigNumberFitTo(p1,n))

//================================================
//       .
//================================================

//          
//          .
//           
//             .
//         - , 
//        - .
//
//          .
//           
//          .

int    _CBNL_C  cBigNumberComp (                //  p1, p2.
                const   CBPTR(CBNL) p1,         // .
                const   CBPTR(CBNL) p2          // .
        )                                       //  -1  p1 <  p2
                                                //   0  p1 == p2
                                                //   1  p1  > p2
{                                               // p1, p2  .
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //    p1.
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //    p2.
  CBNL lp1 = CBPTRBASE(p1)[n1];                 //   p1.
  CBNL lp2 = CBPTRBASE(p2)[n2];                 //   p2.

//        .

  if (n1 == n2)                                 //  p1, p2 .
  {
    if (lp1 != lp2) goto NotSameSignWord;       //    .
    n1 -= (n1 != 0);                            //   .
  }
  else if (n1 > n2)                             //   p1 , 
  {                                             //   
    lp2 >>= (BITS - 1); --n1;                   //   p2.
    if (lp1 != lp2) goto NotSameSignWord;       //    .
    if (n1 > n2)                                //   .
    {
      do                                        //  .
      {
        lp1 = p1 [n1]; --n1;                    //  .
        if (lp1 != lp2) goto NotSame;           //   .
      }
      while (n1 > n2);                          //   .
    }
  }
  else // (n1 < n2)                             //   p2 , 
  {                                             //   
    lp1 >>= (BITS - 1); --n2;                   //   p1.
    if (lp1 != lp2) goto NotSameSignWord;       //    .
    if (n1 < n2)                                //   .
    {
      do                                        //  .
      {
        lp2 = p2 [n2]; --n2;                    //  .
        if (lp1 != lp2) goto NotSame;           //   .
      }
      while (n1 < n2);                          //   .
    }
  }

//         .

  if (n1)
  {
    do                                          //  .
    {
      lp1 = p1 [n1]; lp2 = p2 [n1]; --n1;       //  .
      if (lp1 != lp2) goto NotSame;             //   .
    }
    while (n1);                                 //   .
  }

  return (0);                                   //  .
NotSame:                                        //   .
  return (((unsigned CBNL)lp1 >= (unsigned CBNL)lp2) * 2 - 1);
NotSameSignWord:                                //    .
  return ((lp1 >= lp2) * 2 - 1);
}

//         .
//      , :
//      -  .
//      -        .
//      -      .
//       c       .
//
//             
//       , ..   0   
//         ,    1.

int    _CBNL_C _cBigNumberCompHigh (            //    .
                const   CBPTR(CBNL) p1,         // .
                const   CBNL*       p2,         // .
                        size_t      k2          //  .
        )                                       // 
                                                // -1  p1 <  p2 << k2*BITS
                                                //  0  p1 == p2 << k2*BITS
                                                //  1  p1  > p2 << k2*BITS
{                                               // p1, p2  .
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //    p1.
  size_t n2 = n1 - k2;                          //    p2.
  assert (n1 > k2);                             //  .

  CBNL lp1 = p1 [n1--];                         //   p1.
  CBNL lp2 = p2 [n2--];                         //   p2.
  assert (!n1 || lp1 != (p1 [n1] >> (BITS-1))); //  .
  assert (!n2 || lp2 != (p2 [n2] >> (BITS-1))); //  .

//        .

  if (lp1 != lp2) return ((lp1 > lp2) * 2 - 1); //   .

//         .

  if (n2)
  do                                            //  .
  {
    lp1 = p1 [n1--]; lp2 = p2 [n2--];           //  .
    if (lp1 != lp2)                             //   .
      return (((unsigned CBNL)lp1 > (unsigned CBNL)lp2) * 2 - 1);
  }
  while (n2);                                   //   .

//         .

  if (n1)
  do
  {
    if (p1 [n1--] != 0) return 1;               // .
  }
  while (n1);

  return (0);                                   //  .
}

//          c 0.
//
//           .
//             ,
//        2 (   
//         ,     > 1).
//
//             0-
//         .

inline
CBNL    cBigNumberNot0  (                       //   0:
                const CBPTR(CBNL) p1_debug      //  0  p1 == 0
                )                               //    0.
{
  const CBNL* p1 = CBPTRBASE(p1_debug);         //  .
  size_t n1 = (size_t)(*p1);                    //  .
  return (p1 [n1] | (*p1 >> 1));
}

//================================================
//         .
//================================================

#ifndef _CBIGNUM_ASM                            //    Cbignumf.cpp

//       .
//
//             
//       ,   
//        ,   .

void   _CBNL_C  cBigNumberCopy (                //  p = p1.
                const   CBPTR(CBNL) p1,         //  .
                        EXPTR(CBNL) p           //   *p1 + 1.
        )                                       // p1, p  .
{
  size_t n1 = (size_t)(*p++ = *CBPTRBASE(p1++));//  .
  if (n1)
  {
    do                                          //   .
      { *p++ = *p1++; }                         //  .
    while (--n1 != 0);                          //   .
  }
}

#endif//_CBIGNUM_ASM

//       .
//
//             
//       ,   
//        ,   .

void    cBigNumberCompl (                       //  p = ~p1.
                const   CBPTR(CBNL) p1,         //  .
                        EXPTR(CBNL) p           //  
                                                // max (*p1 + 1, 2).
        )                                       // p1, p  .
{
  size_t n1 = (size_t)(*p++ = *CBPTRBASE(p1++));//  .
  if (n1)
  {
    do                                          //   .
      { *p++ = ~*p1++; }                        //  .
    while (--n1 != 0);                          //   .
  }
  else
  {
    p [-1] = 1; p [0] = ~(CBNL)0;               //  ~0.
  }
}

//================================================
//           .
//================================================

//           ,
//            0.
//          2   (BITS * k1).
//
//             
//       ,   
//        ,   .

void    cBigNumberCopyShl (                     //  p = p1 << (BITS*k1).
                const   CBPTR(CBNL) p1,         //  .
                        size_t      k1,         //    .
                        EXPTR(CBNL) p           //  
                                                // max (*p1 + k1, 1) + 1.
        )                                       // p1, p  .
{
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .
  if (n1 <= 1 && p1 [n1] == 0) k1 = 0;          //  .
  p1 += n1; *p = (CBNL)(n1 + k1); p += (n1 + k1);
  if (n1)
  do                                            //   .
    { *p-- = *p1--; }                           //  .
  while (--n1 != 0);                            //   .
  if (k1)
  do                                            //   .
    { *p-- = 0; }                               //  .
  while (--k1 != 0);                            //   .
}

//            .
//          2   (BITS * k1).
//
//             
//       ,   
//        ,   .

void    cBigNumberCopyShr (                     //  p = p1 >> (BITS*k1).
                const   CBPTR(CBNL) p1,         //  .
                        size_t      k1,         //    .
                        EXPTR(CBNL) p           //  
                                                // max (*p1 - k1, 1) + 1.
        )                                       // p1, p  .
{
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .
  if (n1 > k1)
  {
    *p++ = (CBNL)(n1 -= k1);                    //  .
    p1 += (k1 + 1);                             // .
    do                                          //   .
      { *p++ = *p1++; }                         //  .
    while (--n1 != 0);                          //   .
  }
  else
  {
    *p = 1; p [1] = p1 [n1] >> (BITS-1);        //  0  -1.
  }
}

#ifndef _CBIGNUM_ASM                            //    Cbignumf.cpp

//          ,
//       cBigNumberCopyShr() and cBigNumberFitTo().
//
//          2   (BITS * k1).
//           k1,  k1
//           .
//
//         , :
//      -    k1.
//
//          .

void   _CBNL_C  cBigNumberCopyShrToM (          //   
                                                // p = p1 >> (BITS*k1).
                const   CBPTR(CBNL) p1,         //  , *p1 > k1.
                        size_t      k1,         //    .
                        EXPTR(CBNL) p           //  
                                                //   max (k1, *p1 - k1) + 1.
        )                                       // p1, p  .
{
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .
  assert (n1 > k1);                             //  .
  n1 -= k1;                                     //   .
  p1 += ++k1;                                   // .

  if (k1 <= n1) k1 = n1 + 1;                    //    .
  *p++ = (CBNL) k1;                             //    .
  k1 -= n1;                                     //   .

  CBNL lp1;
  do
    *p++ = lp1 = *p1++;                         //  .
  while (--n1 != 0);

  lp1 >>= (BITS-1);                             // .
  do
    *p++ = lp1;                                 //  .
  while (--k1 != 0);
}

//          .

void   _CBNL_C  cBigNumberCopyShrUToM (         //   
                                                // p = p1 >> (BITS*k1).
                const   CBPTR(CBNL) p1,         //  , *p1 > k1.
                        size_t      k1,         //    .
                        EXPTR(CBNL) p           //  
                                                //   max (k1, *p1 - k1) + 1.
        )                                       // p1, p  .
{
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .
  assert (n1 > k1);                             //  .
  n1 -= k1;                                     //   .
  p1 += ++k1;                                   // .

  if (k1 <= n1) k1 = n1 + 1;                    //    .
  *p++ = (CBNL) k1;                             //    ,
  k1 -= n1;                                     //   0-.

  do
    *p++ = *p1++;                               //  .
  while (--n1 != 0);

  do
    *p++ = 0;                                   //  0-.
  while (--k1 != 0);
}

//        ,  ,
//          cBigNumberFitTo().
//
//          .

void   _CBNL_C  cBigNumberClearTo (             //   .
                        EXPTR(CBNL) p1,         //   n + 1.
                        size_t      n           //  .
        )
{
  *p1++ = (CBNL) n;                             //  .
  if (n)
  do
    *p1++ = 0;                                  // .
  while (--n != 0);
}

#endif//_CBIGNUM_ASM

//               0-.
//
//          .

void    cBigNumberCutOut (                      // .
                const   CBPTR(CBNL) p1,         //  .
                        size_t      k1,         //  .
                        size_t      n,          //  .
                        EXPTR(CBNL) p           //   n1 + 1.
        )                                       // p1, p  .
{
  assert ((size_t)(*CBPTRBASE(p1)) >= k1 + n);  //  .
  *p++ = (CBNL)(n + 1);                         //  .
  if (n > 0)                                    //  .
  {
    p1 += (k1 + 1);                             // .
    do                                          //   .
      { *p++ = *p1++; }                         //  .
    while (--n != 0);                           //   .
  }
  *p = 0;                                       //  .
}

//================================================
//       .
//================================================

//              1.
//      1)        .
//      2)   .
//      3)    ,     100..(),
//            .
//               11..  100..(),
//            .
//
//             
//       ,   
//        ,   .

size_t _CBNL_C _cBigNumberNeg (                 //   p = -p1.
                const   CBPTR(CBNL) p1,         //  .
                        EXPTR(CBNL) p           //   *p1 + 2.
        )                                       // p1, p  .
{
  size_t n1 = (size_t)(*CBPTRBASE(p1++));       //  .
  p++;
  size_t n = n1;                                //  .
  if (n)
  do                                            //   .
  {
    CBNL lp;                                    //  .
    if ((*p = lp = -*p1) != 0)                  //  .
    {                                           //   .
      if (--n != 0)                             //   ?
      {                                         //   :
        do                                      //  .
          { ++p1; ++p; *p = lp = ~*p1; }        //   .
        while (--n != 0);                       //   .
        return (n1 - (lp == (p [-1] >> (BITS-1))));
      }                                         //   ?
                                                //    , 
      if (lp != CBNL_MIN) return (n1);          //   
      p [1] = 0; return (n1 + 1);               //   .
    }
  }
  while ((++p1, ++p, --n) != 0);                //    .

  return (n1);                                  //   .
}
//#define cBigNumberNeg(p1,p)   (size_t)(*(p)=_cBigNumberNeg(p1,p))

//           .
//
//      :        CBNL_MIN
//                        .
//
//           .

void    cBigNumberMNegF (                       //   p1 = -p1.
                        EXPTR(CBNL) p1          //    .
        )
{
  size_t n1 = (size_t)(*CBPTRBASE(p1++));       //  .
  if (n1)
  do                                            //   .
  {
    if ((*p1 = -*p1) != 0)                      //  .
    {                                           //   .
      if (--n1 != 0)                            //   ?
      {                                         //   :
        do                                      //  .
          { ++p1; *p1 = ~*p1; }                 //   .
        while (--n1 != 0);                      //   .
      }
      break;
    }
  }
  while ((++p1, --n1) != 0);                    //    .
}

//       1:
//      1)    1     .
//      2)    ,     100..(),
//            .
//               11..  100..(),
//            .
//
//             
//       ,   
//        ,   .

size_t  _cBigNumberMInc (                       //  p1 = p1 + 1.
                        EXPTR(CBNL) p1          //   *p1 + 2.
        )
{
  size_t n1 = (size_t)(*p1++);                  //  .
  size_t n = n1;                                //  .

  if (n)                                        //     .
  {
    do                                          //   1.
    {
      CBNL lp;                                  //  .
      if ((*p1 = lp = *p1 + 1) != 0)            //  1.
      {                                         //   .
        if (--n != 0)                           //   ?
        {                                       //   1 
          if (--n != 0) return (n1);            //   ,  .
          return (n1 - (p1 [1] == (lp >> (BITS-1))));
        }                                       //    , 
        if (lp != CBNL_MIN) return (n1);        //   
        p1 [1] = 0; return (n1 + 1);            //   .
      }
    }
    while ((++p1, --n) != 0);                   //    1.
  }
  else { *p1 = 1; n1 = 1; }                     //   .

  return (n1);                                  //   .
}
//#define cBigNumberMInc(p1)    (size_t)(*(p1)=_cBigNumberMInc(p1))

//       1:
//      1)    1    ,   ~0.
//      2)    ,     011..(),
//            .
//               00..  011..(),
//            .
//
//             
//       ,   
//        ,   .

size_t  _cBigNumberMDec (                       //  p1 = p1 - 1.
                        EXPTR(CBNL) p1          //   *p1 + 2.
        )
{
  size_t n1 = (size_t)(*p1++);                  //  .
  size_t n = n1;                                //  .

  if (n)                                        //     .
  {
    do                                          //   1.
    {
      CBNL lp;                                  //  .
      if ((*p1 = lp = *p1 - 1) != ~(CBNL)0)     //  1.
      {                                         //   .
        if (--n != 0)                           //   ?
        {                                       //   1 
          if (--n != 0) return (n1);            //   ,  .
          return (n1 - (p1 [1] == (lp >> (BITS-1))));
        }                                       //    , 
        if (lp != CBNL_MAX) return (n1);        //   
        p1 [1] = ~(CBNL)0; return (n1 + 1);     //   .
      }
    }
    while ((++p1, --n) != 0);                   //    1.
  }
  else { *p1 = -1; n1 = 1; }                    //   .

  return (n1);                                  //   .
}
//#define cBigNumberMDec(p1)    (size_t)(*(p1)=_cBigNumberMDec(p1))

//           
//            
//        ,   
//        .    
//         ,    
//       1, ..    .
//
//             
//       ,   
//        ,   .

size_t  _cBigNumberMMul2 (                      //  p1 <<= 1.
                        EXPTR(CBNL) p1          //   *p1 + 2.
        )
{
  size_t n1 = (size_t)(*p1++);                  //  .
  size_t n = n1;                                //  .
  CBNL num = 0;                                 //   .

  if (n)
  do                                            //   .
  {
    CBNL pass = (unsigned CBNL)num >> (BITS-1); //    .
    num = *p1;                                  //    .
    *p1++ = (num << 1) | pass;                  //    .
  }
  while (--n != 0);                             //    .

  num >>= (BITS-2);                             //  
  n1 += (num != (*p1 = num >> 1));              //  .

  return (n1);                                  //  .
}
//#define cBigNumberMMul2(p1)   (size_t)(*(p1)=_cBigNumberMMul2(p1))

//          .

size_t  _cBigNumberMul2 (                       //  p = p1 << 1.
                const   CBPTR(CBNL) p1,         // .
                        EXPTR(CBNL) p           //   *p1 + 2.
        )
{
  size_t n1 = (size_t)(*CBPTRBASE(p1++));       //  .
  p++;
  CBNL num = 0;                                 //   .
  size_t n = n1;                                //  .

  if (n)
  do                                            //   .
  {
    CBNL pass = (unsigned CBNL)num >> (BITS-1); //    .
    num = *p1++;                                //    .
    *p++ = (num << 1) | pass;                   //    .
  }
  while (--n != 0);                             //    .

  num >>= (BITS-2);                             //  
  n1 += (num != (*p = num >> 1));               //  .

  return (n1);                                  //  .
}
//#define cBigNumberMul2(p1,p)  (size_t)(*(p)=_cBigNumberMul2(p1,p))

//           
//          .
//         ,  - .
//             ,
//          .
//
//             
//       ,   
//        ,   .

size_t  _cBigNumberMDiv2 (                      //  p1 >>= 1.
                        EXPTR(CBNL) p1          //   *p1 + 1.
        )
{
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n = n1;                                //  .
  p1 += n;                                      //  .

  if (n)                                        //  ?
  {
    if (--n != 0)                               //   .
    {
      CBNL num = *p1;                           //    .
      n1 -= (num == (*p1-- = (num >> 1)));      //     
                                                // ,  0  ~0.
      do                                        //   .
      {
        CBNL pass = num << (BITS-1);            //    .
        num = *p1;                              //    .
        *p1-- = ((unsigned CBNL)num >> 1) | pass;
      }                                         //    .
      while (--n != 0);                         //    .
    }
    else                                        //   .
    {
      (*p1) >>= 1;                              // .
    }
  }
  return (n1);                                  //  .
}
//#define cBigNumberMDiv2(p1)   (size_t)(*(p1)=_cBigNumberMDiv2(p1))

//          .

size_t  _cBigNumberDiv2 (                       //  p = p1 << 1.
                const   CBPTR(CBNL) p1,         // .
                        EXPTR(CBNL) p           //   *p1 + 1.
        )
{
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .
  size_t n = n1;                                //  .
  p1 += n;                                      //  .
  p  += n;                                      //  .

  if (n)                                        //  ?
  {
    if (--n != 0)                               //   .
    {
      CBNL num = *p1--;                         //    .
      n1 -= (num == (*p-- = (num >> 1)));       //     
                                                // ,  0  ~0.
      do                                        //   .
      {
        CBNL pass = num << (BITS-1);            //    .
        num = *p1--;                            //    .
        *p-- = ((unsigned CBNL)num >> 1) | pass;//    .
      }
      while (--n != 0);                         //    .
    }
    else                                        //   .
    {
      *p = (*p1) >> 1;                          // .
    }
  }
  return (n1);                                  //  .
}
//#define cBigNumberDiv2(p1,p)  (size_t)(*(p)=_cBigNumberDiv2(p1,p))

//================================================
//        .
//================================================

//       ,       
//          1..ns-1   *p + 2.
//           
//       ;    
//          .
//            
//      ,   .
//      ns = BITS      ,  inline cBigNumberTab()
//      ns = BITS/2      

void    _cBigNumberTab (                        //   .
                        EXPTR(CBNL) p,          //    
                        CBNC        ns          // (max (*p, 1) + 2) * ns + 1.
        )                                       //   
{                                               // p << 1..ns-1,  *p + 2.
  size_t n = cBigNumberFit (p);                 //   .
  p [n + 1] = p [n] >> (BITS-1);                //  .
  n += 2;
  EXPTR(CBNL) pp = p;                           //  .
  while (--ns > 0)                              //  .
  {
    pp += n;
    cBigNumberMul2 (p, pp);                     //    .
    p = pp;
  }                                             //    .
}
//#define cBigNumberTab(p1,ns)  (_cBigNumberTab(p1,BITS))

//================================================
//       .
//================================================

//          
//          .
//         .
//
//       :
//      - ,      .
//      -      
//            .
//
//             
//       ,   ,   
//          -     .

size_t  _cBigNumberXor  (                       //  mod2 p = p1 ^ p2.
                const   CBPTR(CBNL) p1,         // .
                const   CBPTR(CBNL) p2,         //  (  p1).
                        EXPTR(CBNL) p           //   *p1 + 1.
        )                                       // p1, p2, p  .
{
  size_t n1 = (size_t)(*CBPTRBASE(p1++));       //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2++));       //  .
  p++;
  assert (n1 >= n2);
  if (n1 == 0) return 0;                        // ,  0 .

  {
    CBNL lp2 = 0;                               //   p2.

//        p1, p2.

    {
      size_t n;                                 //  .
      if ((n = n2) != 0)
      {
        do { *p++ = *p1++ ^ (lp2 = *p2++); }    //   p1, p2.
        while (--n != 0);                       //    p1, p2.
      }
    }

//        p1,  p1  p2.

    {
      lp2 >>= (BITS-1);                         //   p2.
      size_t n;                                 //  .
      if ((n = n1 - n2) != 0)
      {
        do { *p++ = *p1++ ^ lp2; }              //   p1.
        while (--n != 0);                       //    p1.
      }
    }
    --p;                                        //  .
  }

//       -     p,   0  1
//             .

  {
    CBNL pass;                                  //  .
    CBNL lp;                                    //  .
    size_t n = n1;                              //  .
    if (n)                                      //      
    {                                           //   
      lp = *p;                                  //   0   1, 
      do continue;                              //   .
      while (--n != 0 &&
        (pass = lp, lp = p [-1], --p, pass == (lp >> (BITS-1))));
    }                                           //     ,
    else { p [1] = 0; }                         //   .

    return (n + 1);                             //   p.
  }
}
//#define cBigNumberXor(p1,p2,p) (size_t)(*(p)=_cBigNumberXor(p1,p2,p))

size_t  _cBigNumberAnd  (                       //  p = p1 & p2.
                const   CBPTR(CBNL) p1,         // .
                const   CBPTR(CBNL) p2,         //  (  p1).
                        EXPTR(CBNL) p           //   *p1 + 1.
        )                                       // p1, p2, p  .
{
  size_t n1 = (size_t)(*CBPTRBASE(p1++));       //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2++));       //  .
  p++;
  assert (n1 >= n2);
  if (n1 == 0) return 0;                        // ,  0 .

  {
    CBNL lp2 = 0;                               //   p2.

//        p1, p2.

    {
      size_t n;                                 //  .
      if ((n = n2) != 0)
      {
        do { *p++ = *p1++ & (lp2 = *p2++); }    //   p1, p2.
        while (--n != 0);                       //    p1, p2.
      }
    }

//        p1,  p1  p2.

    {
      lp2 >>= (BITS-1);                         //   p2.
      size_t n;                                 //  .
      if ((n = n1 - n2) != 0)
      {
        do { *p++ = *p1++ & lp2; }              //   p1.
        while (--n != 0);                       //    p1.
      }
    }
    --p;                                        //  .
  }

//       -     p,   0  1
//             .

  {
    CBNL pass;                                  //  .
    CBNL lp;                                    //  .
    size_t n = n1;                              //  .
    if (n)                                      //      
    {                                           //   
      lp = *p;                                  //   0   1, 
      do continue;                              //   .
      while (--n != 0 &&
        (pass = lp, lp = p [-1], --p, pass == (lp >> (BITS-1))));
    }                                           //     ,
    else { p [1] = 0; }                         //   .

    return (n + 1);                             //   p.
  }
}
//#define cBigNumberAnd(p1,p2,p) (size_t)(*(p)=_cBigNumberAnd(p1,p2,p))

size_t  _cBigNumberOr  (                        //  p = p1 & p2.
                const   CBPTR(CBNL) p1,         // .
                const   CBPTR(CBNL) p2,         //  (  p1).
                        EXPTR(CBNL) p           //   *p1 + 1.
        )                                       // p1, p2, p  .
{
  size_t n1 = (size_t)(*CBPTRBASE(p1++));       //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2++));       //  .
  p++;
  assert (n1 >= n2);
  if (n1 == 0) return 0;                        // ,  0 .

  {
    CBNL lp2 = 0;                               //   p2.

//        p1, p2.

    {
      size_t n;                                 //  .
      if ((n = n2) != 0)
      {
        do { *p++ = *p1++ | (lp2 = *p2++); }    //   p1, p2.
        while (--n != 0);                       //    p1, p2.
      }
    }

//        p1,  p1  p2.

    {
      lp2 >>= (BITS-1);                         //   p2.
      size_t n;                                 //  .
      if ((n = n1 - n2) != 0)
      {
        do { *p++ = *p1++ | lp2; }              //   p1.
        while (--n != 0);                       //    p1.
      }
    }
    --p;                                        //  .
  }

//       -     p,   0  1
//             .

  {
    CBNL pass;                                  //  .
    CBNL lp;                                    //  .
    size_t n = n1;                              //  .
    if (n)                                      //      
    {                                           //   
      lp = *p;                                  //   0   1, 
      do continue;                              //   .
      while (--n != 0 &&
        (pass = lp, lp = p [-1], --p, pass == (lp >> (BITS-1))));
    }                                           //     ,
    else { p [1] = 0; }                         //   .

    return (n + 1);                             //   p.
  }
}
//#define cBigNumberOr(p1,p2,p)  (size_t)(*(p)=_cBigNumberOr(p1,p2,p))

//================================================
//         .
//================================================

//          
//          .
//         ()  
//        ()     .
//
//       :
//      - ,      .
//      -      
//            .
//
//             
//       ,   ,   
//          -     .

size_t  _cBigNumberAdd  (                       //  p = p1 + p2.
                const   CBPTR(CBNL) p1,         // .
                const   CBPTR(CBNL) p2,         //  (  p1).
                        EXPTR(CBNL) p           //   *p1 + 2.
        )                                       // p1, p2, p  .
{
  size_t n1 = (size_t)(*CBPTRBASE(p1++));       //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2++));       //  .
  p++;
  assert (n1 >= n2);
  if (n1 == 0) return 0;                        // Return if 0 words.

  unsigned CBNL pass = 0;                       //     p.
        //      pass
        // unsigned CBNL   pass >>   .
  {
    CBNL lp1 = 0;                               //   p1.
    CBNL lp2 = 0;                               //   p2.

//        p1, p2.

    {
      size_t n;                                 //  .
      if ((n = n2) != 0)
      {
        do                                      //   p1, p2.
        {
          lp1 = *p1++; lp2 = *p2++;
          pass = (~(*p++ = (pass >> (BITS-1)) + lp1 + lp2) & (lp1 ^ lp2))
                                                           | (lp1 & lp2);
        }
        while (--n != 0);                       //    p1, p2.
      }
    }

//           p1,  p1  p2.

    {
      size_t n;                                 //  .
      if ((n = n1 - n2) != 0)
      {
        const CBNL *pp = p1;                    // .
        if ((lp2 & CBNL_MIN) == 0)              // p2 .
        {
          do                                    //   p1.
          {
            lp1 = *pp++;
            pass = ~(*p++ = (pass >> (BITS-1)) + lp1) & lp1;
          }
          while (--n != 0);                     //    p1.
        }
        else                                    // p2 .
        {
          do                                    //   p1.
          {
            lp1 = *pp++;
            pass = ~(*p++ = (pass >> (BITS-1)) + lp1 - 1) | lp1;
          }
          while (--n != 0);                     //    p1.
        }
      }
    }
    --p;                                        //  .

//          p1, p2.
//           p    0  1.
//        p   pass.

    pass = (pass >> (BITS-1)) + ((lp1) >> (BITS-1)) + ((lp2) >> (BITS-1));
  }

//       -     p,   0  1
//             .

  {
    CBNL lp = *p;                               //  .
    size_t n = n1;                              //  ,  .
    if (n && (CBNL)pass == (lp >> (BITS-1)))    //      
    {                                           //   
      do continue;                              //   0   1, 
      while (--n != 0 &&                        //   .
        (pass = lp, lp = p [-1], --p, (CBNL)pass == (lp >> (BITS-1))));
    }
    else { p [1] = pass; }                      //   .

    return (n + 1);                             //   p.
  }
}
//#define cBigNumberAdd(p1,p2,p) (size_t)(*(p)=_cBigNumberAdd(p1,p2,p))

//           :
//            .

size_t  _cBigNumberSub  (                       //  p = p1 - p2.
                const   CBPTR(CBNL) p1,         // .
                const   CBPTR(CBNL) p2,         //  (  p1).
                        EXPTR(CBNL) p           //   *p1 + 2.
        )                                       // p1, p2, p  .
{
  size_t n1 = (size_t)(*CBPTRBASE(p1++));       //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2++));       //  .
  p++;
  assert (n1 >= n2);
  if (n1 == 0) return 0;                        // Return if 0 words.

  unsigned CBNL pass = ~(unsigned CBNL)0;       //     p.
        //      pass
        // unsigned CBNL   pass >>   .
        //     .
  {
    CBNL lp1 = 0;                               //   p1.
    CBNL lp2 = ~(CBNL)0;                        //   ~p2.

//        p1, ~p2.

    {
      size_t n;                                 //  .
      if ((n = n2) != 0)
      {
        do                                      //   p1, p2.
        {
          lp1 = *p1++; lp2 = ~(*p2++);
          pass = (~(*p++ = (pass >> (BITS-1)) + lp1 + lp2) & (lp1 ^ lp2))
                                                           | (lp1 & lp2);
        }
        while (--n != 0);                       //    p1, p2.
      }
    }

//           p1,  p1  p2.

    {
      size_t n;                                 //  .
      if ((n = n1 - n2) != 0)
      {
        const CBNL *pp = p1;                    // .
        if ((lp2 & CBNL_MIN) == 0)              // p2 .
        {
          do                                    //   p1.
          {
            lp1 = *pp++;
            pass = ~(*p++ = (pass >> (BITS-1)) + lp1) & lp1;
          }
          while (--n != 0);                     //    p1.
        }
        else                                    // p2 .
        {
          do                                    //   p1.
          {
            lp1 = *pp++;
            pass = ~(*p++ = (pass >> (BITS-1)) + lp1 - 1) | lp1;
          }
          while (--n != 0);                     //    p1.
        }
      }
    }
    --p;                                        //  .

//          p1, p2~.
//           p    0  1.
//        p   pass.

    pass = (pass >> (BITS-1)) + ((lp1) >> (BITS-1)) + ((lp2) >> (BITS-1));
  }

//       -     p,   0  1
//             .

  {
    CBNL lp = *p;                               //  .
    size_t n = n1;                              //  ,  .
    if (n && (CBNL)pass == (lp >> (BITS-1)))    //      
    {                                           //   
      do continue;                              //   0   1, 
      while (--n != 0 &&                        //   .
        (pass = lp, lp = p [-1], --p, (CBNL)pass == (lp >> (BITS-1))));
    }
    else { p [1] = pass; }                      //   .

    return (n + 1);                             //   p.
  }
}
//#define cBigNumberSub(p1,p2,p) (size_t)(*(p)=_cBigNumberSub(p1,p2,p))

//         .

size_t  _cBigNumberSubS (                       //  p = p2 - p1.
                const   CBPTR(CBNL) p1,         // .
                const   CBPTR(CBNL) p2,         //  (  p1).
                        EXPTR(CBNL) p           //   *p1 + 2.
        )                                       // p1, p2, p  .
{
  size_t n1 = (size_t)(*CBPTRBASE(p1++));       //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2++));       //  .
  p++;
  assert (n1 >= n2);
  if (n1 == 0) return 0;                        // Return if 0 words.

  unsigned CBNL pass = ~(unsigned CBNL)0;       //     p.
        //      pass
        // unsigned CBNL   pass >>   .
        //     .
  {
    CBNL lp1 = ~(CBNL)0;                        //   ~p1.
    CBNL lp2 = 0;                               //   p2.

//        ~p1, p2.

    {
      size_t n;                                 //  .
      if ((n = n2) != 0)
      {
        do                                      //   p1, p2.
        {
          lp1 = ~(*p1++); lp2 = *p2++;
          pass = (~(*p++ = (pass >> (BITS-1)) + lp1 + lp2) & (lp1 ^ lp2))
                                                           | (lp1 & lp2);
        }
        while (--n != 0);                       //    p1, p2.
      }
    }

//           p1,  p1  p2.

    {
      size_t n;                                 //  .
      if ((n = n1 - n2) != 0)
      {
        const CBNL *pp = p1;                    // .
        if ((lp2 & CBNL_MIN) == 0)              // p2 .
        {
          do                                    //   p1.
          {
            lp1 = ~(*pp++);
            pass = ~(*p++ = (pass >> (BITS-1)) + lp1) & lp1;
          }
          while (--n != 0);                     //    p1.
        }
        else                                    // p2 .
        {
          do                                    //   p1.
          {
            lp1 = ~(*pp++);
            pass = ~(*p++ = (pass >> (BITS-1)) + lp1 - 1) | lp1;
          }
          while (--n != 0);                     //    p1.
        }
      }
    }
    --p;                                        //  .

//          ~p1, p2.
//           p    0  1.
//        p   pass.

    pass = (pass >> (BITS-1)) + ((lp1) >> (BITS-1)) + ((lp2) >> (BITS-1));
  }

//       -     p,   0  1
//             .

  {
    CBNL lp = *p;                               //  .
    size_t n = n1;                              //  ,  .
    if (n && (CBNL)pass == (lp >> (BITS-1)))    //      
    {                                           //   
      do continue;                              //   0   1, 
      while (--n != 0 &&                        //   .
        (pass = lp, lp = p [-1], --p, (CBNL)pass == (lp >> (BITS-1))));
    }
    else { p [1] = pass; }                      //   .

    return (n + 1);                             //   p.
  }
}
//#define cBigNumberSubS(p1,p2,p) (size_t)(*(p)=_cBigNumberSubS(p1,p2,p))

//================================================
//        .
//================================================


//        0- + 1 (, ).

#ifndef _CBIGNUM_MT
static  size_t  _cBigNumberSkip = 1;            //  0- + 1.
#else //_CBIGNUM_MT
#define _cBigNumberSkip 1
#endif//_CBIGNUM_MT

//         0-.

size_t _CBNL_C  cBigNumberSkipLow0 (            //  0-.
                const   CBPTR(CBNL) p1          //   .
)                                               //   0- + 1.
{
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .
  size_t n = 1;                                 //  0- + 1.

  if (n1 != 0)
  do
  {
    if (p1 [n] != 0) break;                     //   .
    n++;
  }
  while (--n1 != 0);

#ifndef _CBIGNUM_MT
  _cBigNumberSkip = n;                          //  0- + 1.
#endif//_CBIGNUM_MT

  return (n);                                   //  0- + 1.
}

//               .
//
//          ,  
//       ,    0.
//
//        0,    ,  
//         0  0    0.

size_t _CBNL_C  cBigNumberCopySkipLow0 (        //  p = p1 >> exwords(p1).
                const   CBPTR(CBNL) p1,         //   .
                        EXPTR(CBNL) p           //   *p1 + 1.
        )                                       // p1, p  .
                                                //   0-.
{
#ifndef _CBIGNUM_MT
  _cBigNumberSkip = 1;                          //   0-.
#endif//_CBIGNUM_MT

  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .

//      .

  if (n1)                                       //      
  {                                             //   
    CBNL pass, lp = p1 [n1];                    //   0   1, 
    do continue;                                //   .
    while (--n1 != 0 &&
        (pass = lp, lp = p1 [n1], pass == (lp >> (BITS-1))));
    ++n1; ++p1;

//        0-  .

    size_t k1 = 0;                              //   0-.
    do                                          //  0-.
    {
      if (p1 [k1] != 0)                         //   .
      {
        p1 += k1;                               // .
        *p++ = (CBNL)n1;                        //  .
        do                                      //   .
          { *p++ = *p1++; }                     //  .
        while (--n1 != 0);                      //   .
        return (k1);                            //   0-.
      }
      k1++;                                     //   0-
    }
    while (--n1 != 0);
  }

//         0  0 ,    .

  *p = 0;                                       //   0
  return (0);                                   //  0 .
}

#ifndef _CBIGNUM_ASM                            //    Cbignumf.cpp

//           
//          .   .
//
//         , :
//      -     ,    
//            ,   .
//      -       0.
//           cBigNumberSkipLow0()
//          0-   .
//
//          ,  
//             .

void   _CBNL_C  cBigNumberMAddM (               //  p1 += p2<<k2*BITS.
                        EXPTR(CBNL) p1,         // ,  .
                const   CBPTR(CBNL) p2,         //   <=*p1-k2.
                        size_t      k2          //   .
        )                                       // p1, p2  .
{
  const CBPTR(CBNL) pp = p1 + (size_t)(*p1);    //   p1.
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //   p2.
#ifndef _CBIGNUM_MT
  assert (_cBigNumberSkip > 0);                 //  .
#endif//_CBIGNUM_MT
  assert ((size_t)(*p1) >= n2 + k2);            //  .
  assert (n2 >= _cBigNumberSkip);               //  .
  p1 += k2;                                     //  p2.

  unsigned CBNL pass = 0;                       // : 0  1.
        // unsigned CBNL   pass >>   .
  {
    const CBPTR(CBNL) ppn = p1 + n2;            //    p2.
    p1 += _cBigNumberSkip;                      //   p1.
    p2 += _cBigNumberSkip;                      //   p2.
    CBNL lp1;                                   //   p1.
    CBNL lp2;                                   //   p2.

//        p1, p2.
//          :
//      pass = ((~(*p1 = (pass >> (BITS-1)) + lp1 + lp2) & (lp1 ^ lp2))
//                                                       | (lp1 & lp2))
//            :
//      pass += (lp1 + lp2)     // *p1 = pass
//      lp1  = ~(lp1 ^ lp2)     //  lp1  .
//      pass = ~(pass | lp1)    //    
//      pass |= (lp1 & lp2)     //   a & b = ~(a^b) & b.
//            
//           Pentium.

    for (;;)                                    //   p1, p2.
    {
      lp1 = *p1;        lp2 = *p2;              //   p1, p2.
      pass += lp1;      lp1 ^= lp2;
      pass += lp2;      lp1 = ~lp1;
      *p1 = pass;       pass |= lp1;
      lp1 &= lp2;       pass = ~pass;
      ++p2;             pass |= lp1;
      if (p1 >= ppn)    break;
      ++p1;             pass >>= (BITS-1);
    }
    if ((CBNL)(lp2 ^= pass) >= 0) return;       //    .
  }

//           p1,  p1  p2.
//      : p1     ,
//                   pass     .

  {
    CBNL lp1;                                   //   p1.
    if ((CBNL)pass < 0)                         // p2 .
    {
      do                                        //   p1.
      {
        if (p1 >= pp) break;
        lp1 = *++p1;
      }
      while ((~(*p1 = lp1 + 1) & lp1) < 0);
    }
    else                                        // p2 .
    {
      do                                        //   p1.
      {
        if (p1 >= pp) break;
        lp1 = *++p1;
      }
      while ((~(*p1 = lp1 - 1) | lp1) >= 0);
    }
  }
}

//           
//          .   .
//
//         , :
//      -     ,    
//            ,   .
//      -       0.
//           cBigNumberSkipLow0()
//          0-   .
//
//          ,  
//             .

void   _CBNL_C  cBigNumberMSubM (               //  p1 -= p2<<k2*BITS.
                        EXPTR(CBNL) p1,         // ,  .
                const   CBPTR(CBNL) p2,         //   <=*p1-k2.
                        size_t      k2          //   .
        )                                       // p1, p2  .
{
  const CBPTR(CBNL) pp = p1 + (size_t)(*p1);    //   p1.
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //   p2.
#ifndef _CBIGNUM_MT
  assert (_cBigNumberSkip > 0);                 //  .
#endif//_CBIGNUM_MT
  assert ((size_t)(*p1) >= n2 + k2);            //  .
  assert (n2 >= _cBigNumberSkip);               //  .
  p1 += k2;                                     //  p2.

  CBNL pass = 0;                                // : 0  1.
        // CBNL   pass >>   .
  {
    const CBPTR(CBNL) ppn = p1 + n2;            //    p2.
    p1 += _cBigNumberSkip;                      //   p1.
    p2 += _cBigNumberSkip;                      //   p2.
    CBNL lp1;                                   //   p1.
    CBNL lp2;                                   //   p2.

//        p1, p2.
//          :
//      pass = (((*p1 = (pass >> (BITS-1)) + lp1 - lp2) | (lp1 ^ lp2))
//                                                     & (~lp1 | lp2))
//            :
//      pass += (lp1 - lp2)     // *p1 = pass
//      pass |= (lp1 ^= lp2)    //  lp1  .
//      pass = ~pass;           //    
//      pass |= (lp1 & ~lp2)    //   a & ~b = (a^b) & ~b.
//      pass = ~pass;
//            
//           Pentium.

    for (;;)                                    //   p1, p2.
    {
      lp1 = *p1;        lp2 = *p2;              //   p1, p2.
      pass += lp1;      lp1 ^= lp2;
      pass -= lp2;      lp2 = ~lp2;
      *p1 = pass;       pass |= lp1;
      lp1 &= lp2;       pass = ~pass;
      ++p2;             pass |= lp1;
      if (p1 >= ppn)    break;
      ++p1;             pass >>= (BITS-1);
                        pass = ~pass;
    }
    if ((CBNL)(lp2 ^= pass) >= 0) return;       //    .
  }

//           p1,  p1  p2.
//      : p1     ,
//                   pass     .

  {
    CBNL lp1;                                   //   p1.
    if ((CBNL)pass < 0)                         // p2 .
    {
      do                                        //   p1.
      {
        if (p1 >= pp) break;
        lp1 = *++p1;
      }
      while ((~(*p1 = lp1 + 1) & lp1) < 0);
    }
    else                                        // p2 .
    {
      do                                        //   p1.
      {
        if (p1 >= pp) break;
        lp1 = *++p1;
      }
      while ((~(*p1 = lp1 - 1) | lp1) >= 0);
    }
  }
}

//           
//         .   .
//
//           
//       , ..   0   
//         ,    1.
//      :    2.2      0,
//                      . 
//                   inline  cBigNumberMSubD.
//
//         , :
//      -    .
//      -     ,    
//         .
//      -       0.
//      -        .
//      -      ,
//           .
//           cBigNumberSkipLow0()
//          0-  .
//
//       ,     2.2, 
//            ,
//          0.    .
//      :     _cBigNumberMSubD() 
//                 . Inline  cBigNumberMSubD() 
//                  .
//
//             
//       ,    
//          .

size_t _CBNL_C _cBigNumberMSubD (               //  p1 -= p2<<k2*BITS.
                        EXPTR(CBNL) p1,         // ,  .
#ifndef _CBNL_TAB_FULL
                const   CBPTR(CBNL) p2,         //   <=*p1-k2.
#else //_CBNL_TAB_FULL
                const   CBNL*       p2,         //   *p1-k2.
#endif//_CBNL_TAB_FULL
                        size_t      k2          //   .
        )                                       // p1, p2  .
{
#ifndef _CBNL_TAB_FULL                          //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //   p2.
  assert ((p1 [(size_t)(*p1)] ^ p2 [n2]) >= 0); //  .
  assert ((size_t)(*p1) >= n2 + k2);            //  .
#else //_CBNL_TAB_FULL                          //  .
  size_t n2 = (size_t)(*p1) - k2;               //   p2.
#endif//_CBNL_TAB_FULL
#ifndef _CBIGNUM_MT
  assert (_cBigNumberSkip > 0);                 //  .
#endif//_CBIGNUM_MT
  assert (n2 >= _cBigNumberSkip);               //  .
  p1 += k2;                                     //  p2.

  CBNL pass = 0;                                // : 0  -1.
        // CBNL   pass >>   .
  {
    const CBPTR(CBNL) ppn = p1 + n2;            //    p2.
    p1 += _cBigNumberSkip;                      //   p1.
    p2 += _cBigNumberSkip;                      //   p2.
    CBNL lp1;                                   //   p1.
    CBNL lp2;                                   //   p2.

//        p1, p2.
//          :
//      pass = (((*p1 = (pass >> (BITS-1)) + lp1 - lp2) | (lp1 ^ lp2))
//                                                     & (~lp1 | lp2))
//            :
//      pass += (lp1 - lp2)     // *p1 = pass
//      pass |= (lp1 ^= lp2)    //  lp1  .
//      pass &=~(lp1 & ~lp2)    //    
//                              //   a & ~b = (a^b) & ~b.
//            
//           Pentium.

    for (;;)                                    //   p1, p2.
    {
      lp1 = *p1;        lp2 = *p2;              //   p1, p2.
      pass += lp1;      lp1 ^= lp2;
      pass -= lp2;      lp2 = ~lp2;
      *p1 = pass;       lp2 &= lp1;
      if (p1 >= ppn)    break;
      lp2 = ~lp2;       pass |= lp1;
      ++p1;             pass &= lp2;
      ++p2;             pass >>= (BITS-1);
    }
  }

//       -     p,   0  1
//             .
//      : p1     ,
//                       pass.

  {
    size_t n1 = n2 + k2;

//         :
//      do continue;
//      while (--n1 != 0 &&
//              lp1 == (lp1 = pass, pass = p1 [-1], --p1, pass >> (BITS-1)));

    for (;;)
    {
      CBNL lp1;                                 //  .
      CBNL lp2;                                 //  .
      if (--n1 == 0)    break;                  //   .
      lp2 = p1 [-1];    --p1;
      lp1 = pass;       pass = lp2;
      lp2 >>= (BITS-1);
      if (lp1 != lp2)   break;
    }
    return (n1 + 1);                            //   p.
  }
}
//#define cBigNumberMSubD(p1,p2,k2) (size_t)(*(p1)=_cBigNumberMSubD(p1,p2,k2))

//          1 .
//        .
//
//      ,     0.
//           cBigNumberSkipLow0()
//          0-  .
//
//           
//            
//        ,   
//        .    
//         ,    
//       1, ..    .
//
//             
//       ,   
//        ,   .

size_t _CBNL_C _cBigNumberMMul2M (              //  p1 <<= 1.
                        EXPTR(CBNL) p1          //   *p1 + 2.
        )
{
  size_t n1 = (size_t)(*p1);                    //  .
#ifndef _CBIGNUM_MT
  assert (_cBigNumberSkip > 0);                 //  .
#endif//_CBIGNUM_MT
  assert (n1 >= _cBigNumberSkip);               //  .

  const CBPTR(CBNL) pp = p1 + n1;               //   p1.
  p1 += _cBigNumberSkip;                        //    p1.
  CBNL num = 0;                                 //   .
  do                                            //   .
  {
    CBNL pass = (unsigned CBNL)num >> (BITS-1); //    .
    num = *p1;                                  //    .
    *p1++ = (num << 1) | pass;                  //    .
  }
  while (p1 <= pp);                             //   .

  num >>= (BITS-2);                             //  
  n1 += (num != (*p1 = num >> 1));              //  .

  return (n1);                                  //  .
}
//#define cBigNumberMMul2M(p1)   (size_t)(*(p1)=_cBigNumberMMul2M(p1))

//          1 .
//            .
//
//      , :
//      -    0.
//      -      .
//           cBigNumberSkipLow0()
//          0-  .
//
//           
//          .
//         ,  - .
//             ,
//          .
//
//             
//       ,   
//        ,   .

size_t _CBNL_C _cBigNumberMDiv2D (              //  p1 >>= 1.
                        EXPTR(CBNL) p1          //   *p1 + 1.
        )
{
  size_t n1 = (size_t)(*p1);                    //  .
#ifndef _CBIGNUM_MT
  assert (_cBigNumberSkip > 0);                 //  .
#endif//_CBIGNUM_MT
  assert (n1 >= _cBigNumberSkip);               //  .
  assert ((p1 [_cBigNumberSkip] & (CBNL)1)==0); //   .

  const CBPTR(CBNL) pp = p1 + _cBigNumberSkip;  //    p1.
  p1 += n1;                                     //  .
  CBNL num = *p1;                               //    .
  n1 -= (n1 > 1) & (num == (*p1-- = num >> 1)); //     
                                                // ,  0  ~0.
  while (p1 >= pp)                              //   .
  {
    CBNL pass = num << (BITS-1);                //    .
    num = *p1;                                  //    .
    *p1-- = ((unsigned CBNL)num >> 1) | pass;   //    .
  }                                             //    .

  return (n1);                                  //  .
}
//#define cBigNumberMDiv2D(p1)   (size_t)(*(p1)=_cBigNumberMDiv2D(p1))

#endif//_CBIGNUM_ASM

//            .
//      0-     .

void   _CBNL_C  cBigNumberMSubMM (              //  p1 -= p2<<k2*BITS.
                        EXPTR(CBNL) p1,         // ,  .
                const   CBPTR(CBNL) p2,         //   < *p1-k2.
                        size_t      k2          //   .
        )                                       // p1, p2  .
{
  (*(CBNL*)CBPTRBASE(p2))++;                    //  0-.
  cBigNumberMSubM (p1, p2, k2);                 // .
  (*(CBNL*)CBPTRBASE(p2))--;                    //  0-.
}

//              .
//         ,  ,  .

void    cBigNumberMShrM (                       //  p1 >>= BITS.
                        EXPTR(CBNL) p1          //   *p1 + 1.
        )
{
  size_t n1 = (size_t)(*p1);                    //  .
  assert (n1 > 1);                              // .
  *p1 = (CBNL)--n1;
  do                                            //   .
    { p1 [1] = p1 [2]; p1++; }                  //  .
  while ((CBNL)--n1 > 0);                       //   .
}

//             .
//         ,  ,  .

void    cBigNumberMShlD (                       //  p1 <<= BITS.
                        EXPTR(CBNL) p1          //   *p1 + 2.
        )
{
  size_t n1 = (size_t)(*p1);                    //  .
  assert (n1 > 0);                              // .
  *p1 = (CBNL)(n1 + 1);
  do                                            //   .
    { p1 [n1 + 1] = p1 [n1]; }                  //  .
  while ((CBNL)--n1 > 0);                       //   .
  p1 [1] = 0;
}

//          ,  
//       ,     .
//
//             
//       .

void    cBigNumberMAddShl (                     //  p1 += p2<<k2*BITS.
                        EXPTR(CBNL) p1,         // ,  
                                                //   
                                                // max (*p1, *p2 + k2) + 2.
                const   CBPTR(CBNL) p2,         // .
                        size_t      k2          //   .
        )                                       // p1, p2  .
{
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .

  cBigNumberFitTo (p1, n2 + k2 + 1);            // .
#ifndef _CBIGNUM_MT
  _cBigNumberSkip = 1;                          //   0-.
#endif//_CBIGNUM_MT
  if (n2 > 0) cBigNumberMAddM (p1, p2, k2);     //  .

  cBigNumberFit (p1);                           // .
}

void    cBigNumberMSubShl (                     //  p1 -= p2<<k2*BITS.
                        EXPTR(CBNL) p1,         // ,  
                                                //   
                                                // max (*p1, *p2 + k2) + 2.
                const   CBPTR(CBNL) p2,         // .
                        size_t      k2          //   .
        )                                       // p1, p2  .
{
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .

  cBigNumberFitTo (p1, n2 + k2 + 1);            // .
#ifndef _CBIGNUM_MT
  _cBigNumberSkip = 1;                          //   0-.
#endif//_CBIGNUM_MT
  if (n2 > 0) cBigNumberMSubM (p1, p2, k2);     //  .

  cBigNumberFit (p1);                           // .
}

//================================================
//       ,  
//         .
//================================================

//            .
//            , 
//       cBigNumberTab().  ,  
//            _CBNL_KARATSUBA_MIN * 2.
//            
//       ,       _CBNL_TAB_OPT.
//
//       ,   ,
//      ..   ,   .
//
//             
//       .

void    cBigNumberMAddMulShlTab (               //   
                                                // p += p1 *p2 << k*BITS.
                const   CBPTR(CBNL) p1,         //    .
                const   CBPTR(CBNL) p2,         //  .
                        size_t      k,          //   .
                        EXPTR(CBNL) p           //    
                                                // max (*p, *p1 + *p2 + k) + 2.
        )                                       // p1, p2  .
{
  assert (p1 != p);                             //  .
  assert (p2 != p);                             //  .
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .

//          .

  if (n1 >= cBigNumberSkipLow0 (p1) && n2 != 0) //  ?
  {
    cBigNumberFitTo (p, n1 + n2 + k + 1);       // .
    n1 += 2;                                    //    .
#ifndef _CBIGNUM_TERNARY_MUL
    for (size_t k2 = 0; k2 != n2; k2++)         //    p2.
    {
      CBNL num = p2 [k2 + 1];                   //   p2.
      CBNL mask = 1;                            //    num.
      const CBPTR(CBNL) pp1 = p1;               //  .
      for (;; pp1 += n1)                        //     p2.
      {
        if (num & mask) cBigNumberMAddM (p, pp1, k + k2);
        if ((mask <<= 1) == 0) break;           //  .
      }                                         //     p2.
    }                                           //     p2.
#else //_CBIGNUM_TERNARY_MUL
    CBNL num2 = p2 [n2], num1 = num2;           //    .
    num2 <<= 1;                                 //  .
    CBNL mode = 0;                              // 0=, -1=.
    if ((num1 & num2) < 0)                      //    1.
    {
      cBigNumberMAddM (p, p1, k + n2);          //    n2.
      num1 = ~num1; num2 = ~num2;
      mode = ~(CBNL)0;                          //  .
    }
    p1 += n1 * BITS; p1 -= n1;                  //  .
    for (size_t k2 = n2; k2-- != 0;)            //    p2.
    {
      const CBPTR(CBNL) pp1 = p1;               //  .
      for (size_t kb = BITS;; pp1 -= n1)        //     p2.
      {
        CBNL num = num1;                        //  .
        num1 = num2;                            // 1-  .
        if (kb != 2) num2 <<= 1;                // 2-  .
        else num2 = (k2? p2 [k2]: 0L) ^ mode;   //  .
        if ((num | (num1 & num2) ) < 0)         //  .
        {
           if (mode == 0) cBigNumberMAddM (p, pp1, k + k2);
           else           cBigNumberMSubM (p, pp1, k + k2);
           if (num >= 0) { num1 = ~num1; num2 = ~num2; mode = ~mode; }
        }                                       //  .
        if (--kb == 0) break;                   //  .
      }                                         //     p2.
    }                                           //     p2.
#endif//_CBIGNUM_TERNARY_MUL
  }

  cBigNumberFit (p);                            // .
#ifndef _CBIGNUM_MT
  _cBigNumberSkip = 1;                          //   0-.
#endif//_CBIGNUM_MT
}

void    cBigNumberMSubMulShlTab (               //   
                                                // p -= p1 *p2 << k*BITS.
                const   CBPTR(CBNL) p1,         //    .
                const   CBPTR(CBNL) p2,         //  .
                        size_t      k,          //   .
                        EXPTR(CBNL) p           //    
                                                // max (*p, *p1 + *p2 + k) + 2.
        )                                       // p1, p2  .
{
  assert (p1 != p);                             //  .
  assert (p2 != p);                             //  .
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .

//          .

  if (n1 >= cBigNumberSkipLow0 (p1) && n2 != 0) //  ?
  {
    cBigNumberFitTo (p, n1 + n2 + k + 1);       // .
    n1 += 2;                                    //    .
#ifndef _CBIGNUM_TERNARY_MUL
    for (size_t k2 = 0; k2 != n2; k2++)         //    p2.
    {
      CBNL num = p2 [k2 + 1];                   //   p2.
      CBNL mask = 1;                            //    num.
      const CBPTR(CBNL) pp1 = p1;               //  .
      for (;; pp1 += n1)                        //     p2.
      {
        if (num & mask) cBigNumberMSubM (p, pp1, k + k2);
        if ((mask <<= 1) == 0) break;           //  .
      }                                         //     p2.
    }                                           //     p2.
#else //_CBIGNUM_TERNARY_MUL
    CBNL num2 = p2 [n2], num1 = num2;           //    .
    num2 <<= 1;                                 //  .
    CBNL mode = 0;                              // 0=, -1=.
    if ((num1 & num2) < 0)                      //    1.
    {
      cBigNumberMSubM (p, p1, k + n2);          //    n2.
      num1 = ~num1; num2 = ~num2;
      mode = ~(CBNL)0;                          //  .
    }
    p1 += n1 * BITS; p1 -= n1;                  //  .
    for (size_t k2 = n2; k2-- != 0;)            //    p2.
    {
      const CBPTR(CBNL) pp1 = p1;               //  .
      for (size_t kb = BITS;; pp1 -= n1)        //     p2.
      {
        CBNL num = num1;                        //  .
        num1 = num2;                            // 1-  .
        if (kb != 2) num2 <<= 1;                // 2-  .
        else num2 = (k2? p2 [k2]: 0L) ^ mode;   //  .
        if ((num | (num1 & num2) ) < 0)         //  .
        {
           if (mode == 0) cBigNumberMSubM (p, pp1, k + k2);
           else           cBigNumberMAddM (p, pp1, k + k2);
           if (num >= 0) { num1 = ~num1; num2 = ~num2; mode = ~mode; }
        }                                       //  .
        if (--kb == 0) break;                   //  .
      }                                         //     p2.
    }                                           //     p2.
#endif//_CBIGNUM_TERNARY_MUL
  }

  cBigNumberFit (p);                            // .
#ifndef _CBIGNUM_MT
  _cBigNumberSkip = 1;                          //   0-.
#endif//_CBIGNUM_MT
}

//================================================
//       ,  
//       ,   ,
//         ,
//         .
//================================================

#ifndef _CBIGNUM_HARDWARE_MUL

//            .
//       c,      .
//
//       ,   ,
//      ..   ,   .
//
//             
//       .

void    cBigNumberMAddMulShl (                  //   
                                                // p += p1 * p2 << k*BITS.
                        EXPTR(CBNL) p1,         //   
                                                //   *p1 + 3.
                const   CBPTR(CBNL) p2,         //  .
                        size_t      k,          //   .
                        EXPTR(CBNL) p           //    
                                                // max (*p, *p1 + *p2 + k) + 2.
        )                                       // p1,p2,p   .
{
  assert (p1 != p);                             //  .
  assert (p2 != p);                             //  .
  assert (p2 != p1);                            //  .
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .

//       ,    .

  if (n1 >= cBigNumberSkipLow0 (p1) && n2 != 0) //  ?
  {
    cBigNumberFitTo (p, n1 + n2 + k + 1);       // .
    --n2;
    size_t k2 = 0;
    for (; k2 != n2; k2++)                      //    p2.
    {
      CBNL num = p2 [k2 + 1];                   //   p2.
      if (num == 0) continue;                   // .
      CBNL mask = 1;                            //    num.
      for (;; cBigNumberMMul2M (p1))            //     p2.
      {
        if (num & mask) cBigNumberMAddM (p, p1, k + k2);
        if ((mask <<= 1) == 0) break;           //  .
      }                                         //     p2.
      cBigNumberMMul2M (p1);                    //    .
      cBigNumberMShrM (p1);                     //  .
    }                                           //     p2.
    {
      CBNL num = p2 [k2 + 1];                   //   p2.
      CBNL mask = (num != 0);                   //    num.
      if (num > 0)                              //   num 
      do                                        //   0  p2 < 0.
        mask <<= 1;                             //  mask  num, 
      while ((num <<= 1) > 0);                  //   num  0.
      for (;; cBigNumberMMul2M (p1))            //     p2.
      {
        if (num & mask) cBigNumberMAddM (p, p1, k + k2);
        if ((mask <<= 1) == 0) break;           //  .
      }                                         //     p2.
    }
  }

  cBigNumberFit (p);                            // .
#ifndef _CBIGNUM_MT
  _cBigNumberSkip = 1;                          //   0-.
#endif//_CBIGNUM_MT
}

void    cBigNumberMSubMulShl (                  //   
                                                // p -= p1 * p2 << k*BITS.
                        EXPTR(CBNL) p1,         //   
                                                //   *p1 + 3.
                const   CBPTR(CBNL) p2,         //  .
                        size_t      k,          //   .
                        EXPTR(CBNL) p           //    
                                                // max (*p, *p1 + *p2 + k) + 2.
        )                                       // p1,p2,p   .
{
  assert (p1 != p);                             //  .
  assert (p2 != p);                             //  .
  assert (p2 != p1);                            //  .
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .

//       ,    .

  if (n1 >= cBigNumberSkipLow0 (p1) && n2 != 0) //  ?
  {
    cBigNumberFitTo (p, n1 + n2 + k + 1);       // .
    --n2;
    size_t k2 = 0;
    for (; k2 != n2; k2++)                      //    p2.
    {
      CBNL num = p2 [k2 + 1];                   //   p2.
      if (num == 0) continue;                   // .
      CBNL mask = 1;                            //    num.
      for (;; cBigNumberMMul2M (p1))            //     p2.
      {
        if (num & mask) cBigNumberMSubM (p, p1, k + k2);
        if ((mask <<= 1) == 0) break;           //  .
      }                                         //     p2.
      cBigNumberMMul2M (p1);                    //    .
      cBigNumberMShrM (p1);                     //  .
    }                                           //     p2.
    {
      CBNL num = p2 [k2 + 1];                   //   p2.
      CBNL mask = (num != 0);                   //    num.
      if (num > 0)                              //   num 
      do                                        //   0  p2 < 0.
        mask <<= 1;                             //  mask  num, 
      while ((num <<= 1) > 0);                  //   num  0.
      for (;; cBigNumberMMul2M (p1))            //     p2.
      {
        if (num & mask) cBigNumberMSubM (p, p1, k + k2);
        if ((mask <<= 1) == 0) break;           //  .
      }                                         //     p2.
    }
  }

  cBigNumberFit (p);                            // .
#ifndef _CBIGNUM_MT
  _cBigNumberSkip = 1;                          //   0-.
#endif//_CBIGNUM_MT
}

//            .
//             
//       ,      .
//           
//         .
//
//       ,   ,
//      ..   ,   .
//
//             
//       .

void    cBigNumberMAddMulShlKar (               //   
                                                // p += p1 *p2 << k*BITS.
                        EXPTR(CBNL) p1,         //   
                                                //   *p1 + 3 +
                                                // *p2 < _CBNL_TAB_MIN?
                                                //  (min (*p1, _CBNL_TAB_HIGH)
                                                //   + 2) * (BITS - 1).
                        EXPTR(CBNL) p2,         //  .
                        size_t      k,          //   .
                        EXPTR(CBNL) p           //    
                                                // max (*p, *p1 + *p2 + k + 1)
                                                //                        + 2.
        )                                       // p1, p2  .
{
  assert (p1 != p);                             //  .
  assert (p2 != p);                             //  .
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*p2);                    //  .

//         .

#ifdef  _CBIGNUM_KARATSUBA_MUL
  if (n1 > _CBNL_KARATSUBA_MIN && n2 > _CBNL_KARATSUBA_MIN)
  {

//        1-   .
//      :    p2   .

    while (n1 > n2 * 2 - n2 / 4)                //  .
    {
      CBNL lp = p1 [n1 -= n2];                  //  
      p1 [n1] = (CBNL) n2;                      //    .
      cBigNumberMAddMulShlKar (p1 + n1, p2, k + n1, p);
      p1 [n1] = lp;                             //  .
      p1 [n1 + 1] = 0; n1 += (lp < 0);          //   0-.
      p1 [0] = (CBNL) n1;                       //   .
    }

//            .

    size_t n = (n1 >= n2? n1: n2 - 1) / 2;      //   .

//      :     p   
//                  ,  p1   p2   ,
//                    p2      p2.

    cBigTemp c12; c12.checkexpand (n * 2 + 5);
    EXPTR(CBNL) p12 = EXPTRTYPE(c12);           //   .

    cBigTemp c1; c1.checkexpand (n + 2);
    cBigTemp c2; c2.checkexpand (n + 4);
    cBigNumberCopyShr (p2, n, EXPTRTYPE(c2));   //   p2  c2.

//       p1   n    p1     p2.
//      :    c2   .

    if (n1 > n)
    {
      cBigNumberCopyShr (p1, n, EXPTRTYPE(c1)); //   p1  c1.
      CBNL lp = p1 [n];                         //  
      p1 [n] = (CBNL)(n1 - n);                  //    .
      p12 [0] = 0;                              //   .
      cBigNumberMAddMulShlKar (p1 + n, EXPTRTYPE(c2), 0, p12);
                                                //  c1 * c2.
      cBigNumberMAddShl (p, p12, k + n * 2);    //  c1 * c2.
      cBigNumberMSubShl (p, p12, k + n);        //  c1 * c2.
      p1 [n] = lp;                              //  .
      p1 [n + 1] = 0;                           //   0-.
      p1 [0] = (CBNL)(n + (lp < 0));            //   p1.
      cBigNumberMAddShl (EXPTRTYPE(c1), p1, 0); //  c1 + p1.
    }
    else
      cBigNumberCopy (p1, EXPTRTYPE(c1));       //  p1  c1.

//       p2    n  .

    assert (n2 > n);
    {
      size_t nc2 = c2.length() + 1;             //   0-.
      c2.item (0) = (CBNL) nc2;
      ((EXPTR(CBNL)) EXPTRTYPE(c2)) [nc2] = 0;

      CBNL lp = p2 [n + 1];                     //  .
      p2 [n + 1] = 0;                           //   0-.
      p2 [0] = (CBNL)(n + 1);                   //   p2.
      cBigNumberMAddShl (EXPTRTYPE(c2), p2, 0); //  c2 + p2.
      p2 [n + 1] = lp;                          //  .

      p2 [0] = (CBNL) n;                        //   0-.
      p12 [0] = 0;                              //   .
      cBigNumberMAddMulShlKar (p1, p2, 0, p12); //  p1 * p2.
      p2 [0] = (CBNL) n2;                       //   p2.

      c2.item (0) = (CBNL)(c2.length() - (c2.hiword() == 0));
                                                //   0-.
      cBigNumberCopy (CBPTRTYPE(c1), p1);       //  (c1+p2)*(c2+p2).
      cBigNumberMAddMulShlKar (p1, EXPTRTYPE(c2), k + n, p);

      cBigNumberMSubShl (p, p12, k + n);        //  p1 * p2.
      cBigNumberMAddShl (p, p12, k);            //  p1 * p2.
    }

    return;
  }
#endif//_CBIGNUM_KARATSUBA_MUL

//       1-   ,  2-  .
//
//            ,  
//        ,      0-.
//           _CBNL_TAB_OPT + 1 ,
//        0-     , 
//           _CBNL_TAB_HIGH   
//        0-.
//
//          .

#ifdef  _CBIGNUM_BLOCK_MUL
  if (n1 > _CBNL_TAB_HIGH)
  {                                             //   
    --n1;                                       //  .
    do                                          //   .
    {
      n1 -= _CBNL_TAB_OPT;                      //    .
      CBNL lp = p1 [n1];                        //  
      p1 [n1] = _CBNL_TAB_OPT + 1;              //    .
#ifdef  _CBIGNUM_SHIFTTAB_MUL
      if (n2 >= _CBNL_TAB_MIN) {                //   ?
        cBigNumberTab (p1 + n1);                //   .
        cBigNumberMAddMulShlTab (p1 + n1, p2, k + n1, p);
      } else
#endif//_CBIGNUM_SHIFTTAB_MUL
        cBigNumberMAddMulShl (p1 + n1, p2, k + n1, p);
      p1 [n1 + 1] = 0;                          //   0-.
      p1 [n1] = lp;                             //  .
    }
    while (n1 >= _CBNL_TAB_HIGH);
    p1 [0] = (CBNL)(n1 + 1);                    //   .
  }
#endif//_CBIGNUM_BLOCK_MUL

//        .

#ifdef  _CBIGNUM_SHIFTTAB_MUL
#ifdef  _CBIGNUM_BLOCK_MUL
  if (n2 >= _CBNL_TAB_MIN) {                    //   ?
#else
  if (n2 >= _CBNL_TAB_MIN && n1 <= _CBNL_TAB_HIGH) {
#endif//_CBIGNUM_BLOCK_MUL
    cBigNumberTab (p1);                         //   .
    cBigNumberMAddMulShlTab (p1, p2, k, p);
  } else
#endif//_CBIGNUM_SHIFTTAB_MUL
    cBigNumberMAddMulShl (p1, p2, k, p);
}

void    cBigNumberMSubMulShlKar (               //   
                                                // p -= p1 * p2 << k*BITS.
                        EXPTR(CBNL) p1,         //   
                                                //   *p1 + 3 +
                                                // *p2 < _CBNL_TAB_MIN?
                                                //  (min (*p1, _CBNL_TAB_HIGH)
                                                //   + 2) * (BITS - 1).
                        EXPTR(CBNL) p2,         //  .
                        size_t      k,          //   .
                        EXPTR(CBNL) p           //    
                                                // max (*p, *p1 + *p2 + k + 1)
                                                //                        + 2.
        )                                       // p1, p2  .
{
  assert (p1 != p);                             //  .
  assert (p2 != p);                             //  .
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*p2);                    //  .

//         .

#ifdef  _CBIGNUM_KARATSUBA_MUL
  if (n1 > _CBNL_KARATSUBA_MIN && n2 > _CBNL_KARATSUBA_MIN)
  {

//        1-   .
//      :    p2   .

    while (n1 > n2 * 2 - n2 / 4)                //  .
    {
      CBNL lp = p1 [n1 -= n2];                  //  
      p1 [n1] = (CBNL) n2;                      //    .
      cBigNumberMSubMulShlKar (p1 + n1, p2, k + n1, p);
      p1 [n1] = lp;                             //  .
      p1 [n1 + 1] = 0; n1 += (lp < 0);          //   0-.
      p1 [0] = (CBNL) n1;                       //   .
    }

//            .

    size_t n = (n1 >= n2? n1: n2 - 1) / 2;      //   .

//      :     p   
//                  ,  p1   p2   ,
//                    p2      p2.

    cBigTemp c12; c12.checkexpand (n * 2 + 5);
    EXPTR(CBNL) p12 = EXPTRTYPE(c12);           //   .

    cBigTemp c1; c1.checkexpand (n + 2);
    cBigTemp c2; c2.checkexpand (n + 4);
    cBigNumberCopyShr (p2, n, EXPTRTYPE(c2));   //   p2  c2.

//       p1   n    p1     p2.
//      :    c2   .

    if (n1 > n)
    {
      cBigNumberCopyShr (p1, n, EXPTRTYPE(c1)); //   p1  c1.
      CBNL lp = p1 [n];                         //  
      p1 [n] = (CBNL)(n1 - n);                  //    .
      p12 [0] = 0;                              //   .
      cBigNumberMAddMulShlKar (p1 + n, EXPTRTYPE(c2), 0, p12);
                                                //  c1 * c2.
      cBigNumberMSubShl (p, p12, k + n * 2);    //  c1 * c2.
      cBigNumberMAddShl (p, p12, k + n);        //  c1 * c2.
      p1 [n] = lp;                              //  .
      p1 [n + 1] = 0;                           //   0-.
      p1 [0] = (CBNL)(n + (lp < 0));            //   p1.
      cBigNumberMAddShl (EXPTRTYPE(c1), p1, 0); //  c1 + p1.
    }
    else
      cBigNumberCopy (p1, EXPTRTYPE(c1));       //  p1  c1.

//       p2    n  .

    assert (n2 > n);
    {
      size_t nc2 = c2.length() + 1;             //   0-.
      c2.item (0) = (CBNL) nc2;
      ((EXPTR(CBNL)) EXPTRTYPE(c2)) [nc2] = 0;

      CBNL lp = p2 [n + 1];                     //  .
      p2 [n + 1] = 0;                           //   0-.
      p2 [0] = (CBNL)(n + 1);                   //   p2.
      cBigNumberMAddShl (EXPTRTYPE(c2), p2, 0); //  c2 + p2.
      p2 [n + 1] = lp;                          //  .

      p2 [0] = (CBNL) n;                        //   0-.
      p12 [0] = 0;                              //   .
      cBigNumberMAddMulShlKar (p1, p2, 0, p12); //  p1 * p2.
      p2 [0] = (CBNL) n2;                       //   p2.

      c2.item (0) = (CBNL)(c2.length() - (c2.hiword() == 0));
                                                //   0-.
      cBigNumberCopy (CBPTRTYPE(c1), p1);       //  (c1+p2)*(c2+p2).
      cBigNumberMSubMulShlKar (p1, EXPTRTYPE(c2), k + n, p);

      cBigNumberMAddShl (p, p12, k + n);        //  p1 * p2.
      cBigNumberMSubShl (p, p12, k);            //  p1 * p2.
    }

    return;
  }
#endif//_CBIGNUM_KARATSUBA_MUL

//       1-   ,  2-  .
//
//            ,  
//        ,      0-.
//           _CBNL_TAB_OPT + 1 ,
//        0-     , 
//           _CBNL_TAB_HIGH   
//        0-.
//
//          .

#ifdef  _CBIGNUM_BLOCK_MUL
  if (n1 > _CBNL_TAB_HIGH)
  {                                             //   
    --n1;                                       //  .
    do                                          //   .
    {
      n1 -= _CBNL_TAB_OPT;                      //    .
      CBNL lp = p1 [n1];                        //  
      p1 [n1] = _CBNL_TAB_OPT + 1;              //    .
#ifdef  _CBIGNUM_SHIFTTAB_MUL
      if (n2 >= _CBNL_TAB_MIN) {                //   ?
        cBigNumberTab (p1 + n1);                //   .
        cBigNumberMSubMulShlTab (p1 + n1, p2, k + n1, p);
      } else
#endif//_CBIGNUM_SHIFTTAB_MUL
        cBigNumberMSubMulShl (p1 + n1, p2, k + n1, p);
      p1 [n1 + 1] = 0;                          //   0-.
      p1 [n1] = lp;                             //  .
    }
    while (n1 >= _CBNL_TAB_HIGH);
    p1 [0] = (CBNL)(n1 + 1);                    //   .
  }
#endif//_CBIGNUM_BLOCK_MUL

//        .

#ifdef  _CBIGNUM_SHIFTTAB_MUL
#ifdef  _CBIGNUM_BLOCK_MUL
  if (n2 >= _CBNL_TAB_MIN) {                    //   ?
#else
  if (n2 >= _CBNL_TAB_MIN && n1 <= _CBNL_TAB_HIGH) {
#endif//_CBIGNUM_BLOCK_MUL
    cBigNumberTab (p1);                         //   .
    cBigNumberMSubMulShlTab (p1, p2, k, p);
  } else
#endif//_CBIGNUM_SHIFTTAB_MUL
    cBigNumberMSubMulShl (p1, p2, k, p);
}

//             .
//             
//          .
//
//           
//         .
//
//             
//       .

void    cBigNumberMAddMul (                     //   
                                                // p += p1 * p2.
                const   CBPTR(CBNL) p1,         // .
                const   CBPTR(CBNL) p2,         // .
                        EXPTR(CBNL) p           //    
                                                // max (*p, *p1 + *p2 + 1) + 2.
        )                                       // p1, p2, p  .
{
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .

  cBigTemp cBigBuf1;                            //   .
  cBigTemp cBigBuf2;                            //   .
  cBigBuf1.checkexpand ((n2 < _CBNL_TAB_MIN)? (n1 + 2):
                        (n1 < _CBNL_TAB_HIGH)? ((n1 + 3) * BITS + 1):
                          (n1 + 2 + (_CBNL_TAB_HIGH + 2) * BITS + 1));
  cBigBuf2.checkexpand (n2 + 1);                //  .
  EXPTR(CBNL) pp1 = EXPTRTYPE(cBigBuf1);        //   .
  EXPTR(CBNL) pp2 = EXPTRTYPE(cBigBuf2);        //   .

//            
//       0-.   0,    0 .

  size_t k = cBigNumberCopySkipLow0 (p1, pp1);  //  .

  if (CBPTRBASE(p2)[n2] >= 0)                   //  :
  {
    cBigNumberCopy (p2, pp2);                   // .
    cBigNumberMAddMulShlKar (pp1, pp2, k, p);   //  .
  }
  else                                          //  :
  {
    cBigNumberNeg (p2, pp2);                    //  .
    *pp2 = (CBNL)n2;                            //   .
    cBigNumberMSubMulShlKar (pp1, pp2, k, p);   //  .
  }
}

void    cBigNumberMSubMul (                     //   
                                                // p -= p1 * p2.
                const   CBPTR(CBNL) p1,         // .
                const   CBPTR(CBNL) p2,         // .
                        EXPTR(CBNL) p           //    
                                                // max (*p, *p1 + *p2 + 1) + 2.
        )                                       // p1, p2, p  .
{
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .

  cBigTemp cBigBuf1;                            //   .
  cBigTemp cBigBuf2;                            //   .
  cBigBuf1.checkexpand ((n2 < _CBNL_TAB_MIN)? (n1 + 2):
                        (n1 < _CBNL_TAB_HIGH)? ((n1 + 3) * BITS + 1):
                          (n1 + 2 + (_CBNL_TAB_HIGH + 2) * BITS + 1));
  cBigBuf2.checkexpand (n2 + 1);                //  .
  EXPTR(CBNL) pp1 = EXPTRTYPE(cBigBuf1);        //   .
  EXPTR(CBNL) pp2 = EXPTRTYPE(cBigBuf2);        //   .

//            
//       0-.   0,    0 .

  size_t k = cBigNumberCopySkipLow0 (p1, pp1);  //  .

  if (CBPTRBASE(p2)[n2] >= 0)                   //  :
  {
    cBigNumberCopy (p2, pp2);                   // .
    cBigNumberMSubMulShlKar (pp1, pp2, k, p);   //  .
  }
  else                                          //  :
  {
    cBigNumberNeg (p2, pp2);                    //  .
    *pp2 = (CBNL)n2;                            //   .
    cBigNumberMAddMulShlKar (pp1, pp2, k, p);   //  .
  }
}

void    cBigNumberMul (                         //  p = p1 * p2.
                const   CBPTR(CBNL) p1,         // .
                const   CBPTR(CBNL) p2,         // .
                        EXPTR(CBNL) p           //  
                                                // *p1 + *p2 + 3.
        )                                       // p1, p2, p  .
{
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .

  cBigTemp cBigBuf1;                            //   .
  cBigTemp cBigBuf2;                            //   .
  cBigBuf1.checkexpand ((n2 < _CBNL_TAB_MIN)? (n1 + 2):
                        (n1 < _CBNL_TAB_HIGH)? ((n1 + 3) * BITS + 1):
                          (n1 + 2 + (_CBNL_TAB_HIGH + 2) * BITS + 1));
  cBigBuf2.checkexpand (n2 + 1);                //  .
  EXPTR(CBNL) pp1 = EXPTRTYPE(cBigBuf1);        //   .
  EXPTR(CBNL) pp2 = EXPTRTYPE(cBigBuf2);        //   .

//            
//       0-.   0,    0 .

  size_t k = cBigNumberCopySkipLow0 (p1, pp1);  //  .

//        -    cBigNumberMul()
//       cBigNumberMAddMul().     
//      ,    .

  if (CBPTRBASE(p2)[n2] >= 0)                   //  :
  {
    cBigNumberCopy (p2, pp2);                   // .
    p [0] = 0;                                  //  .
    cBigNumberMAddMulShlKar (pp1, pp2, k, p);   //  .
  }
  else                                          //  :
  {
    cBigNumberNeg (p2, pp2);                    //  .
    *pp2 = (CBNL)n2;                            //   .
    p [0] = 0;                                  //  .
    cBigNumberMSubMulShlKar (pp1, pp2, k, p);   //  .
  }
}

//================================================
//           
//          Cbignumf,
//        _CBNL_MUL   .
//================================================

#ifndef NCHECKPTR
#ifdef  __cplusplus
extern "C" {
#endif//__cplusplus
#endif//NCHECKPTR

//         CBNL   .
//        _muldCBNL

#undef  _muldCBNL
#define _muldCBNL   _muldCBNL_c
CBNL   _CBNL_C  _muldCBNL_c (                   //  p = p1 * p2.
                        CBNL    l1,             // .
                        CBNL    l2,             // .
                        CBNL    *p              //   .
        )                                       //   .
{
  CBNL c1 [5]; c1 [0] = 1; c1 [1] = l1;         //   .
  CBNL c2 [3]; c2 [0] = 1; c2 [1] = l2;         //   .
  CBNL c  [5]; c [0] = c [1] = c [2] = 0;       //   .
  EXPTR(CBNL) pp1 = EXPTRTO(CBNL,c1,sizeof(c1)/sizeof(*c1)-1);
  EXPTR(CBNL) pp2 = EXPTRTO(CBNL,c2,sizeof(c2)/sizeof(*c2)-1);
  EXPTR(CBNL) pp  = EXPTRTO(CBNL,c, sizeof(c) /sizeof(*c) -1);

  if (l2 >= 0)                                  //  :
    cBigNumberMAddMulShl (pp1, pp2, 0, pp);     // .
  else {                                        //  :
    c2 [1] = -l2;                               //  .
    cBigNumberMSubMulShl (pp1, pp2, 0, pp);     // .
  }

  *p = c [2];                                   //  .
  return c [1];                                 //  .
}

//          CBNL   .
//        _umuldCBNL

#undef  _umuldCBNL
#define _umuldCBNL  _umuldCBNL_c
unsigned
CBNL   _CBNL_C  _umuldCBNL_c (                  //  l1 * l2.
                unsigned CBNL   l1,             //  .
                unsigned CBNL   l2,             //  .
                unsigned CBNL   *p              //   .
        )                                       //   .
{                                               //   .
  CBNL c1 [5]; c1 [0] = 2; c1 [1] = l1; c1 [2] = 0;
  CBNL c2 [3]; c2 [0] = 1; c2 [1] = l2;         //   .
  CBNL c  [6]; c [0] = c [1] = c [2] = 0;       //   .
  EXPTR(CBNL) pp1 = EXPTRTO(CBNL,c1,sizeof(c1)/sizeof(*c1)-1);
  EXPTR(CBNL) pp2 = EXPTRTO(CBNL,c2,sizeof(c2)/sizeof(*c2)-1);
  EXPTR(CBNL) pp  = EXPTRTO(CBNL,c, sizeof(c) /sizeof(*c) -1);

  cBigNumberMAddMulShl (pp1, pp2, 0, pp);       // .

  *p = c [2];                                   //  .
  return c [1];                                 //  .
}

#ifndef NCHECKPTR
#ifdef  __cplusplus
}
#endif//__cplusplus
#endif//NCHECKPTR

#else //_CBIGNUM_HARDWARE_MUL

//================================================
//         .
//================================================

#ifndef _CBIGNUM_ASM                            //    Cbignumf.cpp

//            
//             CBNL 
//            .
//
//         ,   ,
//      ..   ,   .
//
//         , :
//      -   ,    
//         +      ++
//          ,   .
//      -      0.
//
//          ,  , 
//            ,
//         .    
//       ,     .

void   _CBNL_C  cBigNumberMAddMulM (            //  p1+=p2*l2<<k2*BITS.
                        EXPTR(CBNL) p1,         // ,  .
                const   CBPTR(CBNL) p2,         //  .
                     unsigned CBNL  l2,         //  .
                            size_t  k2          //   .
        )                                       // p1, p2   .
{
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .
  assert ((size_t)(*p1) > n2 + k2 + 1);         //  .
  assert (n2 > 0);                              //  .
  assert (p1 != p2);                            //  .

#ifndef _CBIGNUM_MT
  _cBigNumberSkip = 1;                          //   0-.
#endif//_CBIGNUM_MT

  cBigTemp c; c.checkexpand (n2 + 2);           //   
  EXPTR(CBNL) p = EXPTRTYPE(c);                 //  .
  {
    size_t k = 1;
    do                                          //     p2.
      cULongMul (p2 [k], l2, (unsigned CBNL*)EXPTRINDEX(p + k, 1));
    while ((k += 2) <= n2);                     //     p2.
    p [k] = 0; p [0] = (CBNL) k;                //    -
    cBigNumberMAddM (p1, p, k2);                //   cBigNumberMAddM
  }                                             //    1.
  if (n2 > 1)
  {
    size_t k = 1;
    do                                          //     p2.
      cULongMul (p2 [k + 1], l2, (unsigned CBNL*)EXPTRINDEX(p + k, 1));
    while ((k += 2) < n2);                      //     p2.
    p [k] = 0; p [0] = (CBNL) k;                //    -
    cBigNumberMAddM (p1, p, k2 + 1);            //   cBigNumberMAddM
  }                                             //    1.
}

void   _CBNL_C  cBigNumberMSubMulM (            //  p1-=p2*l2<<k2*BITS
                        EXPTR(CBNL) p1,         // ,  .
                const   CBPTR(CBNL) p2,         //  .
                     unsigned CBNL  l2,         //  .
                            size_t  k2          //   .
        )                                       // p1, p2   .
{
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .
  assert ((size_t)(*p1) > n2 + k2 + 1);         //  .
  assert (n2 > 0);                              //  .
  assert (p1 != p2);                            //  .

#ifndef _CBIGNUM_MT
  _cBigNumberSkip = 1;                          //   0-.
#endif//_CBIGNUM_MT

  cBigTemp c; c.checkexpand (n2 + 2);           //   
  EXPTR(CBNL) p = EXPTRTYPE(c);                 //  .
  {
    size_t k = 1;
    do                                          //     p2.
      cULongMul (p2 [k], l2, (unsigned CBNL*)EXPTRINDEX(p + k, 1));
    while ((k += 2) <= n2);                     //     p2.
    p [k] = 0; p [0] = (CBNL) k;                //    -
    cBigNumberMSubM (p1, p, k2);                //   cBigNumberMSubM
  }                                             //    1.
  if (n2 > 1)
  {
    size_t k = 1;
    do                                          //     p2.
      cULongMul (p2 [k + 1], l2, (unsigned CBNL*)EXPTRINDEX(p + k, 1));
    while ((k += 2) < n2);                      //     p2.
    p [k] = 0; p [0] = (CBNL) k;                //    -
    cBigNumberMSubM (p1, p, k2 + 1);            //   cBigNumberMSubM
  }                                             //    1.
}

#endif//_CBIGNUM_ASM

//             
//          .  ,  
//            _CBNL_KARATSUBA_MIN * 4.
//            
//       ,       _CBNL_MUL_HIGH.
//
//       ,   ,
//      ..   ,   .
//
//          ,  , 
//            ,
//         .    
//       ,     .

void   _CBNL_C  cBigNumberMAddMulShlM (         //   
                                                // p += p1 * p2 << k*BITS.
                const   CBPTR(CBNL) p1,         // .
                const   CBPTR(CBNL) p2,         //  .
                        size_t      k,          //   .
                        EXPTR(CBNL) p           //  
                                                // *p >= *p1 + *p2 + k + 1 -
                                                //           (p1 [*p1] == 0);
        )                                       // p1,p2,p   .
{
  assert (p1 != p);                             //  .
  assert (p2 != p);                             //  .
  size_t n1 = (size_t)(*CBPTRBASE(p1++));       //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .

//      Algorithm with hardware multiplication.

  if (n1 != 0 && n2 != 0)                       //  ?
  {
    CBNL lp1 = *p1++;                           //   p1.

    if (--n1 != 0)
    do                                          //    p1.
    {
      if (lp1 != 0) cBigNumberMAddMulM (p, p2, lp1, k);
      lp1 = *p1++; k++;                         //   p1.
    }
    while (--n1 != 0);                          //     p1.

    if (lp1 > 0)                                //  .
      cBigNumberMAddMulM (p, p2, lp1, k);
    else if (lp1 < 0)                           //  .
      cBigNumberMSubMulM (p, p2, -lp1, k);
  }
}

void   _CBNL_C  cBigNumberMSubMulShlM (         //   
                                                // p -= p1 * p2 << k*BITS.
                const   CBPTR(CBNL) p1,         // .
                const   CBPTR(CBNL) p2,         //  .
                        size_t      k,          //   .
                        EXPTR(CBNL) p           //  
                                                // *p >= *p1 + *p2 + k + 1 -
                                                //           (p1 [*p1] == 0);
        )                                       // p1,p2,p   .
{
  assert (p1 != p);                             //  .
  assert (p2 != p);                             //  .
  size_t n1 = (size_t)(*CBPTRBASE(p1++));       //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .

//      Algorithm with hardware multiplication.

  if (n1 != 0 && n2 != 0)                       //  ?
  {
    CBNL lp1 = *p1++;                           //   p1.

    if (--n1 != 0)
    do                                          //    p1.
    {
      if (lp1 != 0) cBigNumberMSubMulM (p, p2, lp1, k);
      lp1 = *p1++; k++;                         //   p1.
    }
    while (--n1 != 0);                          //     p1.

    if (lp1 > 0)                                //  .
      cBigNumberMSubMulM (p, p2, lp1, k);
    else if (lp1 < 0)                           //  .
      cBigNumberMAddMulM (p, p2, -lp1, k);
  }
}

//        ,     
//          .
//
//      :      ,
//                    p1 ,   ,  
//                      - .  .

void    cBigNumberMAddMulShl (                  //   
                                                // p += p1 * p2 << k*BITS.
                        EXPTR(CBNL) p1,         //  (**).
                const   CBPTR(CBNL) p2,         //  .
                        size_t      k,          //   .
                        EXPTR(CBNL) p           //    
                                                // max (*p, *p1 + *p2 + k) + 2.
        )                                       // p1,p2,p   .
                                                // **  p1  .
{
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .

  cBigNumberFitTo (p, n1 + n2 + k + 1);         // .
  cBigNumberMAddMulShlM (p1, p2, k, p);
  cBigNumberFit (p);                            // .
}

void    cBigNumberMSubMulShl (                  //   
                                                // p -= p1 * p2 << k*BITS.
                        EXPTR(CBNL) p1,         //  (**).
                const   CBPTR(CBNL) p2,         //  .
                        size_t      k,          //   .
                        EXPTR(CBNL) p           //    
                                                // max (*p, *p1 + *p2 + k) + 2.
        )                                       // p1,p2,p   .
                                                // **  p1  .
{
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .

  cBigNumberFitTo (p, n1 + n2 + k + 1);         // .
  cBigNumberMSubMulShlM (p1, p2, k, p);
  cBigNumberFit (p);                            // .
}

//           
//           .
//           
//         .
//
//       ,   ,
//      ..   ,   .
//
//          ,  , 
//            ,
//         .    
//       ,     .

void   _CBNL_C  cBigNumberMAddMulShlKarM (      //   
                                                // p += p1 * p2 << k*BITS.
                        EXPTR(CBNL) p1,         // .
                        EXPTR(CBNL) p2,         //  .
                        size_t      k,          //   .
                        EXPTR(CBNL) p           //  
                                                // *p >= *p1 + *p2 + k + 2.
        )                                       // p1,p2,p   .
                                                //   *p1, *p2.
{
  assert (p1 != p);                             //  .
  assert (p2 != p);                             //  .
#ifdef  _CBIGNUM_KARATSUBA_MUL
  size_t n1 = (size_t)(*p1);                    //  .
#endif//_CBIGNUM_KARATSUBA_MUL
  size_t n2 = (size_t)(*p2);                    //  .

//         .

#ifdef  _CBIGNUM_KARATSUBA_MUL
  if (n1 > _CBNL_KARATSUBA_MIN && n2 > _CBNL_KARATSUBA_MIN)
  {

//        2-   .
//      :     p1  
//                  .  *p1  .

    while (n2 > n1 * 2 - n1 / 4)                //  .
    {
      CBNL lp = p2 [n2 -= n1];                  //  .
      p2 [n2] = (CBNL) n1;                      //  .
      cBigNumberMAddMulShlKarM (p1, p2 + n2, k + n2, p);
      p2 [n2] = lp;                             //  .
      p2 [0] = (CBNL) n2;                       //   .
      p1 [0] = (CBNL) n1;                       //   p1.
    }

#ifndef _CBIGNUM_MT
  _cBigNumberSkip = 1;                          //   0-.
#endif//_CBIGNUM_MT

//            .
//      :     p1  p2  
//                  .  *p1  *p2  .

    assert ((size_t)(*p) >= n1 + n2 + k);       //  .
    size_t n = (n1 > n2? n1 - 1: n2) / 2;       //   .

//       p1    n  .
//       p2   n    p2     p1.
//      :     p   
//                  ,  p2   p1   ,
//                    p1      p1.

    cBigTemp c12; c12.checkexpand (n * 2 + 6);  //   .
    EXPTR(CBNL) p12 = EXPTRTYPE(c12);           //   .

//        p1 *  p2,   p2 +  p2.
//      : p1  p2  ,   *p2.

    assert (n1 > n);
    if (n2 > n)
    {
      CBNL lp1 = p1 [n];                        //  .
      CBNL lp2 = p2 [n];                        //  .
      p1 [n] = (CBNL)(n1 -= n);                 //  .
      p2 [n] = (CBNL)(n2 -= n);                 //  .
      cBigNumberClearTo (p12, n1 + n2 + 2);     //   .
      cBigNumberMAddMulShlKarM (p1 + n, p2 + n, 0, p12);
                                                //   p1 * p2.
      --*EXPTRBASE(p12);                        //  .
      cBigNumberMAddM (p, p12, k + n * 2);      //   p1 * p2.
      cBigNumberMSubM (p, p12, k + n);          //   p1 * p2.
      p1 [n] = lp1;                             //  .
      p2 [n] = lp2;                             //  .

      cBigNumberCopyShrUToM (p2, n, p12);       //   p2.

      CBNL lp = p2 [n + 1];                     //  .
      p2 [n + 1] = 0;                           //   0-.
      *EXPTRBASE(p2) = (CBNL)(n + 1);           //   p2.
      cBigNumberMAddM (p12, p2, 0);             //  + p2.
      *EXPTRBASE(p2) = (CBNL) n;                //   0-.
      n2 = n;                                   //   .
      p2 [n + 1] = lp;                          //  .

      size_t n12 = (size_t)(*EXPTRBASE(p12));   //  .
      while (p12 [n12] == 0 && --n12 != 0) continue;
      *EXPTRBASE(p12) = (CBNL) n12;             //   0-.
    }
    else
      cBigNumberCopy (p2, p12);                 //  p2.

//       ( p1 +  p1) * ( p2 +  p2) 
//                   p1 *  p2.
//      : p1  p2  ,   *p1  *p2.

    {
      cBigNumberCopyShrToM (p1, n, p12 + n + 3);//   p1.
      CBNL lp = p1 [n + 1];                     //  .
      p1 [n + 1] = 0;                           //   0-.
      *EXPTRBASE(p1) = (CBNL)(n + 1);           //   p1.
      cBigNumberMAddM (p12 + n + 3, p1, 0);     //  + p1.
      cBigNumberFit (p12 + n + 3);              // .

      cBigNumberMAddMulShlKarM (p12 + n + 3, p12, k + n, p);
                                                //   p1 * p2.

      cBigNumberClearTo (p12, n + n2 + 3);      //   .
      cBigNumberMAddMulShlKarM (p1, p2, 0, p12);//   p1 * p2.
      (*EXPTRBASE(p12)) -= 2;                   //  .
      cBigNumberMSubM (p, p12, k + n);          //   p1 * p2.
      cBigNumberMAddM (p, p12, k);              //   p1 * p2.

      p1 [n + 1] = lp;                          //  .
    }

    return;
  }
#endif//_CBIGNUM_KARATSUBA_MUL

//       2-   ,  1-  .
//
//            ,  
//        ,      0-.
//           _CBNL_MUL_OPT + 1 ,
//        0-     , 
//           _CBNL_MUL_HIGH   
//        0-.
//
//          .

#ifdef  _CBIGNUM_BLOCK_MUL
  if (n2 > _CBNL_MUL_HIGH)
  {
    do                                          //   .
    {
      n2 -= _CBNL_MUL_OPT + 1;                  //    .
      CBNL lp = p2 [n2];                        //  .
      p2 [n2] = _CBNL_MUL_OPT + 1;              //   .
      cBigNumberMAddMulShlM (p1, p2 + n2, k + n2, p);
      p2 [n2] = lp;                             //  .
    }
    while (n2 >= _CBNL_MUL_HIGH);
    p2 [0] = (CBNL) n2;                         //    .
  }
#endif//_CBIGNUM_BLOCK_MUL

//        .

  cBigNumberMAddMulShlM (p1, p2, k, p);
}

void   _CBNL_C  cBigNumberMSubMulShlKarM (     //   
                                                // p -= p1 * p2 << k*BITS.
                        EXPTR(CBNL) p1,         // .
                        EXPTR(CBNL) p2,         //  .
                        size_t      k,          //   .
                        EXPTR(CBNL) p           //  
                                                // *p >= *p1 + *p2 + k + 2.
        )                                       // p1,p2,p   .
                                                //   *p1, *p2.
{
  assert (p1 != p);                             //  .
  assert (p2 != p);                             //  .
#ifdef  _CBIGNUM_KARATSUBA_MUL
  size_t n1 = (size_t)(*p1);                    //  .
#endif//_CBIGNUM_KARATSUBA_MUL
  size_t n2 = (size_t)(*p2);                    //  .

//         .

#ifdef  _CBIGNUM_KARATSUBA_MUL
  if (n1 > _CBNL_KARATSUBA_MIN && n2 > _CBNL_KARATSUBA_MIN)
  {

//        2-   .
//      :     p1  
//                  .  *p1  .

    while (n2 > n1 * 2 - n1 / 4)                //  .
    {
      CBNL lp = p2 [n2 -= n1];                  //  .
      p2 [n2] = (CBNL) n1;                      //  .
      cBigNumberMSubMulShlKarM (p1, p2 + n2, k + n2, p);
      p2 [n2] = lp;                             //  .
      p2 [0] = (CBNL) n2;                       //   .
      p1 [0] = (CBNL) n1;                       //   p1.
    }

#ifndef _CBIGNUM_MT
  _cBigNumberSkip = 1;                          //   0-.
#endif//_CBIGNUM_MT

//            .
//      :     p1  p2  
//                  .  *p1  *p2  .

    assert ((size_t)(*p) >= n1 + n2 + k);       //  .
    size_t n = (n1 > n2? n1 - 1: n2) / 2;       //   .

//       p1    n  .
//       p2   n    p2     p1.
//      :     p   
//                  ,  p2   p1   ,
//                    p1      p1.

    cBigTemp c12; c12.checkexpand (n * 2 + 6);  //   .
    EXPTR(CBNL) p12 = EXPTRTYPE(c12);           //   .

//        p1 *  p2,   p2 +  p2.
//      : p1  p2  ,   *p2.

    assert (n1 > n);
    if (n2 > n)
    {
      CBNL lp1 = p1 [n];                        //  .
      CBNL lp2 = p2 [n];                        //  .
      p1 [n] = (CBNL)(n1 -= n);                 //  .
      p2 [n] = (CBNL)(n2 -= n);                 //  .
      cBigNumberClearTo (p12, n1 + n2 + 2);     //   .
      cBigNumberMAddMulShlKarM (p1 + n, p2 + n, 0, p12);
                                                //   p1 * p2.
      --*EXPTRBASE(p12);                        //  .
      cBigNumberMSubM (p, p12, k + n * 2);      //   p1 * p2.
      cBigNumberMAddM (p, p12, k + n);          //   p1 * p2.
      p1 [n] = lp1;                             //  .
      p2 [n] = lp2;                             //  .

      cBigNumberCopyShrUToM (p2, n, p12);       //   p2.

      CBNL lp = p2 [n + 1];                     //  .
      p2 [n + 1] = 0;                           //   0-.
      *EXPTRBASE(p2) = (CBNL)(n + 1);           //   p2.
      cBigNumberMAddM (p12, p2, 0);             //  + p2.
      *EXPTRBASE(p2) = (CBNL) n;                //   0-.
      n2 = n;                                   //   .
      p2 [n + 1] = lp;                          //  .

      size_t n12 = (size_t)(*EXPTRBASE(p12));   //  .
      while (p12 [n12] == 0 && --n12 != 0) continue;
      *EXPTRBASE(p12) = (CBNL) n12;             //   0-.
    }
    else
      cBigNumberCopy (p2, p12);                 //  p2.

//       ( p1 +  p1) * ( p2 +  p2) 
//                   p1 *  p2.
//      : p1  p2  ,   *p1  *p2.

    {
      cBigNumberCopyShrToM (p1, n, p12 + n + 3);//   p1.
      CBNL lp = p1 [n + 1];                     //  .
      p1 [n + 1] = 0;                           //   0-.
      *EXPTRBASE(p1) = (CBNL)(n + 1);           //   p1.
      cBigNumberMAddM (p12 + n + 3, p1, 0);     //  + p1.
      cBigNumberFit (p12 + n + 3);              // .

      cBigNumberMSubMulShlKarM (p12 + n + 3, p12, k + n, p);
                                                //   p1 * p2.

      cBigNumberClearTo (p12, n + n2 + 3);      //   .
      cBigNumberMAddMulShlKarM (p1, p2, 0, p12);//   p1 * p2.
      (*EXPTRBASE(p12)) -= 2;                   //  .
      cBigNumberMAddM (p, p12, k + n);          //   p1 * p2.
      cBigNumberMSubM (p, p12, k);              //   p1 * p2.

      p1 [n + 1] = lp;                          //  .
    }

    return;
  }
#endif//_CBIGNUM_KARATSUBA_MUL

//       2-   ,  1-  .
//
//            ,  
//        ,      0-.
//           _CBNL_MUL_OPT + 1 ,
//        0-     , 
//           _CBNL_MUL_HIGH   
//        0-.
//
//          .

#ifdef  _CBIGNUM_BLOCK_MUL
  if (n2 > _CBNL_MUL_HIGH)
  {
    do                                          //   .
    {
      n2 -= _CBNL_MUL_OPT + 1;                  //    .
      CBNL lp = p2 [n2];                        //  .
      p2 [n2] = _CBNL_MUL_OPT + 1;              //   .
      cBigNumberMSubMulShlM (p1, p2 + n2, k + n2, p);
      p2 [n2] = lp;                             //  .
    }
    while (n2 >= _CBNL_MUL_HIGH);
    p2 [0] = (CBNL) n2;                         //    .
  }
#endif//_CBIGNUM_BLOCK_MUL

//        .

  cBigNumberMSubMulShlM (p1, p2, k, p);
}

//        ,     
//          .
//
//      :      Cbignumf.inl  ,
//                       
//                  ,  p1   ,   
//                     - .   Cbignumf.inl.

void    cBigNumberMAddMulShlKar (               //   
                                                // p += p1 *p2 << k*BITS.
                        EXPTR(CBNL) p1,         //  (**).
                        EXPTR(CBNL) p2,         //  .
                        size_t      k,          //   .
                        EXPTR(CBNL) p           //    
                                                // max (*p, *p1 + *p2 + k + 1)
                                                //                        + 2.
        )                                       // p1, p2  .
                                                // **   *p1, *p2.

{
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*p2);                    //  .

  cBigNumberFitTo (p, n1 + n2 + k + 2);         // .
  cBigNumberMAddMulShlKarM (p1, p2, k, p);
  cBigNumberFit (p);                            // .
}

void    cBigNumberMSubMulShlKar (               //   
                                                // p -= p1 * p2 << k*BITS.
                        EXPTR(CBNL) p1,         //  (**).
                        EXPTR(CBNL) p2,         //  .
                        size_t      k,          //   .
                        EXPTR(CBNL) p           //    
                                                // max (*p, *p1 + *p2 + k + 1)
                                                //                        + 2.
        )                                       // p1, p2  .
                                                // **   *p1, *p2.
{
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*p2);                    //  .

  cBigNumberFitTo (p, n1 + n2 + k + 2);         // .
  cBigNumberMSubMulShlKarM (p1, p2, k, p);
  cBigNumberFit (p);                            // .
}

//            , 
//         ,     .
//             .
//
//          
//          ,  p2.
//
//             
//       .

void    cBigNumberMAddMul (                     //   
                                                // p += p1 * p2.
                const   CBPTR(CBNL) p2,         // .
                const   CBPTR(CBNL) p1,         // .
                        EXPTR(CBNL) p           //    
                                                // max (*p, *p1 + *p2 + 1) + 2.
        )                                       // p1, p2, p  .
{
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .

  cBigTemp cBigBuf1;                            //   .
  cBigTemp cBigBuf2;                            //   .
  cBigBuf1.checkexpand (n1);                    //  .
  cBigBuf2.checkexpand (n2 + 1);                //  .
  EXPTR(CBNL) pp1 = EXPTRTYPE(cBigBuf1);        //   .
  EXPTR(CBNL) pp2 = EXPTRTYPE(cBigBuf2);        //   .

  cBigNumberFitTo (p, n1 + n2 + 2);             // .

//            
//       0-.   0,    0 .

  size_t k = cBigNumberCopySkipLow0 (p1, pp1);  //  .

  if (CBPTRBASE(p2)[n2] >= 0)                   //  :
  {
    cBigNumberCopy (p2, pp2);                   // .
    cBigNumberMAddMulShlKarM (pp1, pp2, k, p);  //  .
  }
  else                                          //  :
  {
    cBigNumberNeg (p2, pp2);                    //  .
    *pp2 = (CBNL)n2;                            //   .
    cBigNumberMSubMulShlKarM (pp1, pp2, k, p);  //  .
  }

  cBigNumberFit (p);                            // .
}

void    cBigNumberMSubMul (                     //   
                                                // p -= p1 * p2.
                const   CBPTR(CBNL) p2,         // .
                const   CBPTR(CBNL) p1,         // .
                        EXPTR(CBNL) p           //    
                                                // max (*p, *p1 + *p2 + 1) + 2.
        )                                       // p1, p2, p  .
{
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .

  cBigTemp cBigBuf1;                            //   .
  cBigTemp cBigBuf2;                            //   .
  cBigBuf1.checkexpand (n1);                    //  .
  cBigBuf2.checkexpand (n2 + 1);                //  .
  EXPTR(CBNL) pp1 = EXPTRTYPE(cBigBuf1);        //   .
  EXPTR(CBNL) pp2 = EXPTRTYPE(cBigBuf2);        //   .

  cBigNumberFitTo (p, n1 + n2 + 2);             // .

//            
//       0-.   0,    0 .

  size_t k = cBigNumberCopySkipLow0 (p1, pp1);  //  .

  if (CBPTRBASE(p2)[n2] >= 0)                   //  :
  {
    cBigNumberCopy (p2, pp2);                   // .
    cBigNumberMSubMulShlKarM (pp1, pp2, k, p);  //  .
  }
  else                                          //  :
  {
    cBigNumberNeg (p2, pp2);                    //  .
    *pp2 = (CBNL)n2;                            //   .
    cBigNumberMAddMulShlKarM (pp1, pp2, k, p);  //  .
  }

  cBigNumberFit (p);                            // .
}

void    cBigNumberMul (                         //  p = p1 * p2.
                const   CBPTR(CBNL) p2,         // .
                const   CBPTR(CBNL) p1,         // .
                        EXPTR(CBNL) p           //  
                                                // *p1 + *p2 + 3.
        )                                       // p1, p2, p  .
{
  size_t n1 = (size_t)(*CBPTRBASE(p1));         //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .

  cBigTemp cBigBuf1;                            //   .
  cBigTemp cBigBuf2;                            //   .
  cBigBuf1.checkexpand (n1);                    //  .
  cBigBuf2.checkexpand (n2 + 1);                //  .
  EXPTR(CBNL) pp1 = EXPTRTYPE(cBigBuf1);        //   .
  EXPTR(CBNL) pp2 = EXPTRTYPE(cBigBuf2);        //   .

//            
//       0-.   0,    0 .

  size_t k = cBigNumberCopySkipLow0 (p1, pp1);  //  .

//        -    cBigNumberMul()
//       cBigNumberMAddMul().     
//      ,    .

  if (CBPTRBASE(p2)[n2] >= 0)                   //  :
  {
    cBigNumberCopy (p2, pp2);                   // .
    cBigNumberClearTo (p, n1 + n2 + 2);         //   .
    cBigNumberMAddMulShlKarM (pp1, pp2, k, p);  //  .
  }
  else                                          //  :
  {
    cBigNumberNeg (p2, pp2);                    //  .
    *pp2 = (CBNL)n2;                            //   .
    cBigNumberClearTo (p, n1 + n2 + 2);         //   .
    cBigNumberMSubMulShlKarM (pp1, pp2, k, p);  //  .
  }

  cBigNumberFit (p);                            // .
}

#endif//_CBIGNUM_HARDWARE_MUL

//================================================
//      ,    0.
//================================================

void    cBigNumberDiv0()                        //   0.
{
  cBigNumberMaskDiv0 /= cBigNumberMaskDiv0;
}

//================================================
//        .
//================================================

//           .
//      ,       ,
//             0.
//            ,
//        cBigNumberTab.
//
//              .
//       >= 0.      .
//         0,   ,   0,
//        .
//
//         .
//           .

void    cBigNumberMModDivShlTab (               // 
                                                // p = p1 / p2 << k2*BITS,
                                                //    p1 %= p2 << k2*BITS.
                        EXPTR(CBNL) p1,         // ,  .
                const   CBPTR(CBNL) p2,         //    .
                        size_t      k2,         //   .
                        EXPTR(CBNL) p           //   *p1 + 2.
        )                                       // p1,p2,p   .
{
  assert (cBigNumberIsFit (p1));                //  .
  assert (p1 != p);                             //  .
  assert (p2 != p);                             //  .
  assert (p2 != p1);                            //  .
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .
  size_t n = n2 + k2;                           //    .
  if (n > n1) n = n1;                           //   .
  n = n1 - n + 1;                               //    .

//              ,
//             .
//          ,    
//       .

  *p = (CBNL)(n + 1); p += n; p [1] = 0;        //   p.
  n += k2;                                      //  .

//             .

  if (n2 >= cBigNumberSkipLow0 (p2))            //   0- 
  {                                             //    0.
    CBNL p2h = p2 [n2];                         //   .
    assert ((p1 [n1] ^ p2h) >= 0);              //  .
    CBNL lt = (p2h < 0) * 2 - 1;                //   
                                                //   .
                                                // (p1  p2 >= 0)? -1: 1
    p2h ^= (p2h >> (BITS-1));                   //   p2 < 0.
    size_t nn2 = n + n2;                        //   
    p2h = ((CBNL)1) << (_ulzcntCBNL(p2h) - 1);  //      1.
    n2 += 2;                                    //    .

    do                                          //    .
    {
      p2 += n2 * BITS; --n;                     //    .
      *p = 0;                                   //   .
      unsigned CBNL mask = ((unsigned CBNL)1) << (BITS-1);
                                                //  .
      do                                        //    .
      {                                         //   
        p2 -= n2;                               //     .
        CBNL diff = nn2 - ((unsigned CBNL)p2h >= mask) - n1;
        if (diff <= 0 && (diff < 0 ||           //    
        _cBigNumberCompHigh (p1, p2, n) != lt)) //  ,
        {                                       //   .
          assert (diff < 0 ? p1 [n1] == p2 [(size_t)(*p2) + 1] : 1);
          //   _cBigNumberMSubD()   .
          //        
          //   ,    .
          //    cBigNumberTab()   
          //       1,   .
          n1 = _cBigNumberMSubD (p1, p2, n);    //  .
          p1 [0] = (CBNL) n1;                   //  .
          (*p) += mask;                         //   .
        }
      }
      while ((mask >>= 1) != 0);                //    .
      --p; --nn2;                               //   .
    }
    while (n > k2);                             //    .

    assert ((p1 [(size_t)(*p1)] ^ lt) < 0 ||    //   
            (p1 [(size_t)(*p1)] + *p1) == 1);   //   0.
//  assert (cBigNumberComp (p1, p2) == lt);     //   .
    assert (cBigNumberIsFit (p1));              //  .
  }
  else                                          //  0.
  {                                             //    0
    cBigNumberDiv0();                           // ,  
    do { *p-- = 0; } while (--n);               //   
  }                                             //    0.

  cBigNumberFit (p);                            //  .
  assert (p [(size_t)(*p)] >= 0);               //  .
#ifndef _CBIGNUM_MT
  _cBigNumberSkip = 1;                          //   0-.
#endif//_CBIGNUM_MT
}

#ifdef  _CBNL_TAB_FULL

//            .
//
//              
//             .
//
//              ,
//             .
//           ,  
//       ,       .

void    cBigNumberMModDivShlTab2 (              // 
                                                // p = p1 / p2 << k2*BITS,
                                                //    p1 %= p2 << k2*BITS.
                        EXPTR(CBNL) p1,         // ,  .
                const   CBPTR(CBNL) p2,         //    .
                        size_t      k2,         //   .
                        EXPTR(CBNL) p           //   *p1 + 2.
        )                                       // p1,p2,p   .
{
  assert (cBigNumberIsFit (p1));                //  .
  assert (p1 != p);                             //  .
  assert (p2 != p);                             //  .
  assert (p2 != p1);                            //  .
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .
  size_t n = n2 + k2;                           //    .
  if (n > n1) n = n1;                           //   .
  n = n1 - n + 1;                               //    .

//              ,
//             .
//          ,    
//       .

  *p = (CBNL)(n + 1); p += n; p [1] = 0;        //   p.
  n += k2;                                      //  .

//             .

  if (n2 >= cBigNumberSkipLow0 (p2))            //   0- 
  {                                             //    0.
    CBNL p2h = p2 [n2];                         //   .
    assert ((p1 [n1] ^ p2h) >= 0);              //  .
    CBNL lt = (p2h < 0) * 2 - 1;                //   
                                                //   .
                                                // (p1  p2 >= 0)? -1: 1
    p2h ^= (p2h >> (BITS-1));                   //   p2 < 0.
    size_t nn2 = n + n2;                        //   
    p2h = ((CBNL)1) << (_ulzcntCBNL(p2h) - 1);  //      1.
    n2 += 2;                                    //    .
    p2 += n2 * BITS/2;                          //   .

    do                                          //    .
    {
      const CBNL* pp2 = (const CBNL*)           //    p2.
                        ((const int*)(CBPTRBASE(p2)) - 1);
      --n;                                      //  pp2.
      *p = 0;                                   //   .
      unsigned CBNL mask = ((unsigned CBNL)1) << (BITS-1);
                                                //  .
      do                                        //    .
      {                                         //   
        pp2 -= n2;                              //     .
        CBNL diff = nn2 - ((unsigned CBNL)p2h >= mask) - n1;
        if (diff <= 0 && (diff < 0 ||           //    
        _cBigNumberCompHigh (p1, pp2, n) != lt))//  ,
        {                                       //   .
          n1 = _cBigNumberMSubD (p1, pp2, n);   //  .
          p1 [0] = (CBNL) n1;                   //  .
          (*p) += mask;                         //   .
        }
      }
      while ((unsigned)(mask >>= 1) == 0);      //    .

      pp2 = CBPTRBASE(p2);                      //   p2.
      do                                        //    .
      {                                         //   
        pp2 -= n2;                              //     .
        CBNL diff = nn2 - ((unsigned CBNL)p2h >= mask) - n1;
        if (diff <= 0 && (diff < 0 ||           //    
        _cBigNumberCompHigh (p1, pp2, n) != lt))//  ,
        {                                       //   .
          assert (diff < 0 ? p1 [n1] == pp2 [(size_t)(*pp2) + 1] : 1);
          //   _cBigNumberMSubD()   .
          //        
          //   ,    .
          //    cBigNumberTab()   
          //       1,   .
          n1 = _cBigNumberMSubD (p1, pp2, n);   //  .
          p1 [0] = (CBNL) n1;                   //  .
          (*p) += mask;                         //   .
        }
      }
      while ((mask >>= 1) != 0);                //    .
      --p; --nn2;                               //   .
    }
    while (n > k2);                             //    .

    assert ((p1 [(size_t)(*p1)] ^ lt) < 0 ||    //   
            (p1 [(size_t)(*p1)] + *p1) == 1);   //   0.
//  assert (cBigNumberComp (p1, p2) == lt);     //   .
    assert (cBigNumberIsFit (p1));              //  .
  }
  else                                          //  0.
  {                                             //    0
    cBigNumberDiv0();                           // ,  
    do { *p-- = 0; } while (--n);               //   
  }                                             //    0.

  cBigNumberFit (p);                            //  .
  assert (p [(size_t)(*p)] >= 0);               //  .
#ifndef _CBIGNUM_MT
  _cBigNumberSkip = 1;                          //   0-.
#endif//_CBIGNUM_MT
}

#endif//_CBNL_TAB_FULL

//              
//            .
//         ,      
//      ,   ,    .
//
//              .
//        -      .
//           .
//         0,   ,   0,
//        .
//
//         .
//           .

void    cBigNumberMModDiv (                     //  p = p1 / p2,
                                                //         p1 %= p2.
                        EXPTR(CBNL) p1,         // ,  
                                                //    *p1 + 3 -
                const   CBPTR(CBNL) p2,         // . (p1 [*p1] == 0);
                        EXPTR(CBNL) p           //   *p1 + 3.
        )                                       // p2    p1, p.
{
  assert (cBigNumberIsFit (p1));                //  .
  assert (p1 != p);                             //  .
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .

//           ,   ,
//      ..   0,    _CBIGNUM_SMALL_DIV.

#ifdef  _CBIGNUM_SMALL_DIV
  unsigned CBNL p2h = 0, p2l = 0;               //    0.
  if (n2 - 1 <= _CBIGNUM_SMALL_DIV - 1) { p2l = p2 [1];
                                          p2h = p2 [n2]; }

//            
//          ,
//         _CBIGNUM_SMALL_DIV .

  if ((p2h | p2l) == 0)                         //    
  {                                             //   .
#endif//_CBIGNUM_SMALL_DIV
    cBigTemp cBigBuf2;                          //   .
#ifdef _CBIGNUM_SUBMUL_DIV
    cBigBuf2.checkexpand ((size_t)(n2 + 2));
#else //_CBIGNUM_SUBMUL_DIV
#ifdef  _CBIGNUM_SHIFTTAB_DIV
    CBNL nt = (CBNL)((n2 - n1 + _CBNL_TAB_MIN - 1) & (n2 - _CBNL_TAB_MAX));
    cBigBuf2.checkexpand ((size_t)((nt >= 0)? (n2 + 3):
#ifdef  _CBNL_TAB_FULL
                       (n2 > _CBNL_TAB_FULL)? (n2 + 3) * BITS/2 + 1:
#endif//_CBNL_TAB_FULL
                                              (n2 + 3) * BITS + 1));
#else //_CBIGNUM_SHIFTTAB_DIV
    cBigBuf2.checkexpand ((size_t)(n2 + 3));
#endif//_CBIGNUM_SHIFTTAB_DIV
#endif//_CBIGNUM_SUBMUL_DIV
    EXPTR(CBNL) pp2 = EXPTRTYPE(cBigBuf2);      //   .

//              0-.
//        0,    0 .

    size_t k2 = cBigNumberCopySkipLow0 (p2, pp2);

//        .
//      CBPTRBASE      p2.

    CBNL signquot = p1 [n1] ^ CBPTRBASE(p2)[n2];

#ifndef _CBIGNUM_SUBMUL_DIV

//           .

    if (signquot < 0) cBigNumberNeg (pp2, pp2); //   .

//          .

#ifdef  _CBIGNUM_SHIFTTAB_DIV
    if (nt < 0)
    {
//             
//          .
#ifdef  _CBNL_TAB_FULL
      if (n2 > _CBNL_TAB_FULL)
      {
        _cBigNumberTab (pp2, BITS/2);           //   .
        cBigNumberMModDivShlTab2 (p1, pp2, k2, p);
      }                                         // .
      else
#endif//_CBNL_TAB_FULL
      {
        cBigNumberTab (pp2);                    //   .
        cBigNumberMModDivShlTab (p1, pp2, k2, p);
      }                                         // .
      if (signquot < 0) cBigNumberNeg (p, p);   //   .
      return;
    }
#endif//_CBIGNUM_SHIFTTAB_DIV

//       ,    .

    n2 = (size_t)(*pp2);                        //  .
    if (n2 == 0)                                //  0.
    {                                           //    0
      cBigNumberDiv0();                         // ,  
      p [0] = 1; p [1] = 0;                     //   
      return;                                   //    0.
    }
    assert (cBigNumberIsFit (pp2));             //  .

    size_t n = n2 + k2;                         //    .
    if (n <= n1) {
      n = n1 - n + 1;                           //    .
    } else {                                    //   
      p [0] = 1; p [1] = 0;                     // ,  
      return;                                   //   
    }                                           //    0.

//              ,
//             .
//          ,    
//       .

    *p = (CBNL)(n + 1); p += n; p [1] = 0;      //   p.
    n += k2;                                    //  .

//             .

    assert ((p1 [n1] ^ pp2 [n2]) >= 0);         //   .
    CBNL lt = (pp2 [n2] < 0) * 2 - 1;           //   
                                                //   
                                                // (p1  pp2 >= 0)? -1: 1
    do                                          //    .
    {
      cBigNumberMShlD (pp2); --n;               //     .
      *p = 0;                                   //   .
      unsigned CBNL mask = ((unsigned CBNL)1) << (BITS-1);
                                                //  .
      do                                        //    .
      {
        CBNL diff = (CBNL)cBigNumberMDiv2D (pp2)//    .
                  + (CBNL)n - (CBNL)n1;         //  .
        if (diff <= 0 && (diff < 0 ||           //    
        _cBigNumberCompHigh (p1, pp2, n) != lt))//  ,
        {                                       //   .
          n1 = cBigNumberMSubD (p1, pp2, n);    //  .
          (*p) += mask;                         //   .
        }
      }
      while ((mask >>= 1) != 0);                //    .
      --p;                                      //   .
    }
    while (n > k2);                             //    .

    assert ((p1 [(size_t)(*p1)] ^ lt) < 0 ||    //   
            (p1 [(size_t)(*p1)] + *p1) == 1);   //   0.

#else //_CBIGNUM_SUBMUL_DIV

//         .

    #undef  CPRG
    #define CPRG(a)

    n2 = (size_t)(*pp2);                        //  .
    if (n2 == 0)                                //  0.
    {                                           //    0
      cBigNumberDiv0();                         // ,  
      p [0] = 1; p [1] = 0;                     //   
      return;                                   //    0.
    }
    assert (cBigNumberIsFit (pp2));             //  .

//          .

    unsigned CBNL p2p = pp2 [n2];               //   .
    if ((CBNL)p2p < 0) {
      n2 = cBigNumberNeg (pp2, pp2);            //   
      p2p = pp2 [n2];                           //    .
    }
    void _CBNL_C (*pfNumberMSubM)(EXPTR(CBNL), const CBPTR(CBNL), size_t);
    if (p2p != 0) {                             //   0-
      pfNumberMSubM = cBigNumberMSubM;          //    
    } else {                                    //   .
      pfNumberMSubM = cBigNumberMSubMM; p2p = pp2 [--n2]; *pp2 = (CBNL)n2;
    }
    assert (pp2 [n2] != 0 && n2 > 0);

//      ,     .

    CBNL signrem = p1 [n1];                     //  /.
    if (n1) n1 -= (signrem == 0);               //    0-.
    size_t n = n2 + k2;                         //    .
    if (n <= n1) {
      n = n1 - n + 1;                           //    .
    } else {                                    //   
      p [0] = 1; p [1] = 0;                     // ,  
      return;                                   //   
    }                                           //    0.
    assert (p1 [n1] != 0 && n1 > 0);

//            
//       .     ,    
//       .

    *p = 0; cBigNumberFitTo (p, n + 1);         //   p.
    CBNL pa [3] = { 2, 0, 0 };                  //   .

//         (    ).

    if (signrem < 0) {
      cBigNumberNeg (p1, p1);                   //   .
    }

//             
//       .    cBigNumberMSubMulM.

    *p1 = n1 + 2; p1 [n1 + 2] = p1 [n1 + 1] = 0;

//            .

    if (n2 > 1)                                 //  .
    {
      CBNC nb2 = (CBNC)_ulzcntCBNL (p2p);       //   0-.

//             1  
//       . p2p   .

      p2p = _ushldCBNL (pp2 [n2 - 1], p2p, nb2) + 1;

//             .

      n2 = n1 - n2; assert (n2 >= k2);          //   ().
      unsigned CBNL p1l = p1 [n1 - 1];          //   ,
      unsigned CBNL p1h = p1 [n1];              //   
                                                //  .
//       .

      CBNC nb1 = (CBNC)_ulzcntCBNL (p1h);       //   0-
      if (nb1 < nb2) {                          //   .
        assert (nb2 > 0);
        p1l = _ushrdCBNL (p1l, p1h, BITS - nb2);//    
        p1h = _ushrCBNL (p1h, BITS - nb2);      //    
                                                //   .
        if (p2p) p1h = _udivdCBNL (p1l, p1h, p2p, (unsigned CBNL *)pa + 1);
        CPRG('\n'); CPRG((CBNL)n1); CPRG(' '); CPRG((CBNL)n2);
        CPRG(' '); CPRG((CBNL)nb1); CPRG(' '); CPRG((CBNL)nb2);
        CPRG(' '); CPRG((CBNL)p1h);
        p [n2 - k2 + 1] = p1h;                  //   .
        cBigNumberMSubMulM (p1, pp2, p1h, n2);  //  .
        p1l = p1 [n1 - 1]; p1h = p1 [n1];       //   .
      }

//              
//           ,    
//       .      .

      for (;; p1l = p1 [n1 - 1], p1h = p1 [n1]) //    
      {                                         //   .
        nb1 = (CBNC)_ulzcntCBNL (p1h);          //   0-.
        CPRG('\n'); CPRG((CBNL)n1); CPRG(' '); CPRG((CBNL)n2);
        CPRG(' '); CPRG((CBNL)nb1); CPRG(' '); CPRG((CBNL)nb2);
        if (nb1 < nb2 || p2p <= (               //   .
            p1h = _ushldCBNL (p1l, p1h, nb2))   //    .
            && p2p)                             //    ,
        { pa [1] = 1; CPRG(" 1");               //    
          cBigNumberMAddM (p, EXPTRTO(CBNL, pa, 3), n2 - k2);
          (*pfNumberMSubM)(p1, pp2, n2);        //  .
          continue;
        }                                       //    
        if (n2 == k2) break;                    //    , 
//               
//       ( ).    p2p == 0 
//              p1h.
        if (p2p) {
          p1l = _ushldCBNL ((n1 > 2 ? p1 [n1 - 2] : 0), p1l, nb2);
          p1h = _udivdCBNL (p1l, p1h, p2p, (unsigned CBNL *)pa + 1);
        }                                       //   .
        CPRG(' '); CPRG((CBNL)p1h);             //   ,
        p [n2-- - k2] = p1h;                    //   .
        cBigNumberMSubMulM (p1, pp2, p1h, n2);  //  .

//              
//       ,  nb2 = 0.       
//           .

        if (p1 [n1--] != 0) {                   //     0,
          pa [1] = 1; CPRG("+1");               //    
          cBigNumberMAddM (p, EXPTRTO(CBNL, pa, 3), n2 - k2);
          (*pfNumberMSubM)(p1, pp2, n2);        //  .
          assert (p1 [n1 + 1] == 0);            //    .
        }
      }                                         //   .

//         ,     
//            .

      n2 = n1 - n2;                             //  n2  
      assert (n1 == n2 + k2 && n2 > 0);         //    pp2.
      do continue; while ((p1h = p1 [n2 + k2]) == (p2p = pp2 [n2]) && --n2);
      if (p1h >= p2p) {                         //    ,
        pa [1] = 1; CPRG("+1");                 //    
        cBigNumberMAddM (p, EXPTRTO(CBNL, pa, 3), 0);
        (*pfNumberMSubM)(p1, pp2, k2);          //  .
      }
    }
    else if (n1 - 1 > k2) // n2 == 1            //  ,
    {                                           //  .
      n2 = n1 - 1;                              //   ().
      do                                        //   .
      {                                         //   ,
        unsigned CBNL p1h = p1 [n2 + 1];        //   
        CPRG('\n'); CPRG((CBNL)n2);             //   .
        if (p2p <= p1h) {                       //    ,
          p1h /= p2p;                           //    
          pa [1] = p1h;                         //   ,
          cBigNumberMAddM (p, EXPTRTO(CBNL,pa,3), n2 - k2);
        } else {                                //    ,
          p1h = _udivdCBNL (p1 [n2], p1h, p2p, (unsigned CBNL *)pa + 1);
          p [n2-- - k2] = p1h;                  //    
        }                                       //   .
        CPRG(' '); CPRG((CBNL)p1h);
        cBigNumberMSubMulM (p1, pp2, p1h, n2);  //  .
      }
      while (n2 > k2);                          //   .
    }
    else // n1 == k2 + 1 && n2 == 1             //   .
    {
      unsigned CBNL p1h = p1 [n1];              //   .
      unsigned CBNL pn = p1h / p2p;             //   .
      p [1] = pn;                               //  .
#ifdef  _CBIGNUM_REVERSE_MOD
      p1h -= pn * p2p;                          //  .
#else //_CBIGNUM_REVERSE_MOD
      p1h %= p2p;                               //  .
#endif//_CBIGNUM_REVERSE_MOD
      p1 [n1] = p1h;                            //  .
    }

    //  .

    while (p1 [n1] == 0 && n1 > 1) --n1;        //   0-.
    p1 [0] = n1 + (p1 [n1] < 0);                //    .
    if (signrem < 0) cBigNumberNeg (p1, p1);    //   .

#endif//_CBIGNUM_SUBMUL_DIV

    assert (cBigNumberIsFit (p1));              //  .

    cBigNumberFit (p);                          //  .
    assert (p [(size_t)(*p)] >= 0);             //  .
    if (signquot < 0) cBigNumberNeg (p, p);     //   .

#ifdef  _CBIGNUM_SMALL_DIV
    return;
  }

//           
//       .

  unsigned CBNL p1h = p1 [n1];                  //   .
  CBNL signquot = p1h ^ p2h;                    //  .

//        ,    .
//             
//          0  ~0.

  if (n1 <= n2)                                 //    .
  {
    unsigned CBNL pn = 0;                       //  .

//         ,    ,
//         .

CompareSize:
    if (n1 == n2)                               //  .

//            .

#if _CBIGNUM_SMALL_DIV > 1
    switch (n1)
#endif//_CBIGNUM_SMALL_DIV
    {
#if _CBIGNUM_SMALL_DIV > 1
    case 2:                                     //  ,
    {                                           //  .
      assert (n1 == 2 && n2 == 2);

      if ((CBNL)p2h == ((CBNL)p2l >> (BITS-1))) //    -
        goto LongerDividend;                    //   .

      unsigned CBNL p1l = p1 [1];               //   .

//        .

      if ((CBNL)p1h < 0) {
        p1h = ~p1h + ((p1l = -(CBNL)p1l) == 0); //  .
        if ((CBNL)p1h < 0) goto LongerDividend; //  -CBNL_MIN,0 ,
      }                                         //   
      assert ((CBNL)p1h >= 0);                  //  .

      if ((CBNL)p2h < 0)
        p2h = ~p2h + ((p2l = -(CBNL)p2l) == 0); //  .
      assert (p2h <= (unsigned CBNL)(CBNL_MIN) && (p2h | p2l) > 0);

//           .
//         BITS-1, .. p1h    0.

      unsigned CBNL mask = (unsigned CBNL)1;    //  .
      CBNC nb = (int)_ulzcntCBNL (p2h) - (int)_ulzcntCBNL (p1h);
      if (nb >= 0)                              //    
      {                                         // ,  .
        assert ((unsigned CBNC)nb < BITS);      //   .
        p2h = _ushldCBNL (p2l, p2h, nb);        //  .
        p2l = _ushlCBNL (p2l, nb);
        mask = _ushlCBNL (mask, nb);
        do                                      //    .
        {                                       //    ,
          unsigned CBNL pnh, pnl;               //    
          _sbbCBNL (_subCBNL (p1l, p2l, &pnl), p1h, p2h, &pnh);
          if ((CBNL)pnh >= 0) p1h = pnh; p1l = (CBNL)pnh >= 0? pnl: p1l;
          pn += ((CBNL)pnh >= 0)? mask: 0;      //   .
        }
        while ((p2l = _ushrd1CBNL (p2l, p2h),
                p2h >>= 1, mask >>= 1) != 0);   //    .
      }

      assert ((CBNL)p1h >= 0);                  //  .
      if (p1 [2] < 0)                           //   .
        p1h = ~p1h + ((p1l = -(CBNL)p1l) == 0);
      p1 [0] = 1 + ((CBNL)p1h != ((CBNL)p1l >> (BITS-1)));
      p1 [1] = p1l; p1 [2] = p1h;               //  .
      assert (cBigNumberIsFit (p1));            //  .
      break; /* switch */
    }

//          ,   .

    default: /* n1 == 1 */                      //  ,
                                                //  .
#endif//_CBIGNUM_SMALL_DIV
      assert (n1 == 1 && n2 == 1);

//        .

      if ((CBNL)p1h < 0) p1h = -(CBNL)p1h;      //  .
      assert (p1h <= (unsigned CBNL)(CBNL_MIN));

      if ((CBNL)p2h < 0) p2h = -(CBNL)p2h;      //  .
      assert (p2h <= (unsigned CBNL)(CBNL_MIN) && p2h != 0);

#ifdef  _CBIGNUM_HARDWARE_DIV
#ifdef  _CBIGNUM_REVERSE_MOD
      pn = p1h / p2h; p1h -= pn * p2h;          //   .
#else //_CBIGNUM_REVERSE_MOD
      pn = p1h / p2h; p1h %= p2h;               //   .
#endif//_CBIGNUM_REVERSE_MOD
#else //_CBIGNUM_HARDWARE_DIV

//           .
//         BITS-1, .. p2h   0.

      unsigned CBNL mask = (unsigned CBNL)1;    //  .
      CBNC nb = (int)_ulzcntCBNL (p2h) - (int)_ulzcntCBNL (p1h);
      if (nb >= 0)                              //    
      {                                         // ,  .
        assert ((unsigned CBNC)nb < BITS);      //   .
        p2h <<= nb; mask <<= nb;                //  .
        do                                      //    .
        {
          CBNL pnh = p1h - p2h;                 //    ,
          if (pnh >= 0) p1h = pnh;              //    
          pn += (pnh >= 0)? mask: 0;            //   .
        }
        while ((p2h >>= 1, mask >>= 1) != 0);   //    .
      }
#endif//_CBIGNUM_HARDWARE_DIV

      assert (p1h <= (unsigned CBNL)(CBNL_MIN));
      if (p1 [1] >= 0) p1 [1] = p1h;            //  .
      else             p1 [1] = -(CBNL)p1h;     //   .
    }
    else if ((CBNL)p2h == ((CBNL)p2l >> (BITS-1)) ||
             p2h == 0 && p2l == (((unsigned CBNL)1) << (BITS-1)))
    {                                           //    
      p2h = p2l; --n2; goto CompareSize;        //    
    }                                           //    .

    if (signquot >= 0)                          //  .
    if ((CBNL)pn >= 0)
         { p [0] = 1; p [1] = pn; }             //  .
    else { p [0] = 2; p [1] = pn; p [2] = 0; }  //   .
    else                                        //   .
    if (-(CBNL)pn <= 0)
         { p [0] = 1; p [1] = -(CBNL)pn; }      //  .
    else { p [0] = 2; p [1] = -(CBNL)pn; p [2] = ~(CBNL)0; }
    assert (cBigNumberIsFit (p));               //  .
  }

//         ,    
//        .        
//      ,       .

  else /* n1 > n2 */                            //   .
  {
#if _CBIGNUM_SMALL_DIV > 1
LongerDividend:
#endif//_CBIGNUM_SMALL_DIV
    if ((CBNL)p1h < 0) {                        //   
      p1 [0] = p1h;                             //    
      size_t n = 0;                             //   .
      do ++n; while ((p1 [n] = p1h = -p1 [n]) == 0); ++n;
      if (n <= n1) do p1 [n] = p1h = ~p1 [n]; while (++n <= n1);
      else if ((CBNL)p1h < 0) { p1h = 0; ++n1; }//    
    }                                           // -CBNL_MIN,  
    assert ((CBNL)p1h >= 0);                    //  .

//               0.

    CBNC nb1 = (int)_ulzcntCBNL (p1h) - 1;      //   .
    assert ((unsigned CBNC)nb1 < BITS);         //   .

//            .

#if _CBIGNUM_SMALL_DIV > 1
    switch (n2)
#endif//_CBIGNUM_SMALL_DIV
    {
#if _CBIGNUM_SMALL_DIV > 1
    case 2:                                     //  ,
    if ((CBNL)p2h != ((CBNL)p2l >> (BITS-1)))   //  ,
    {                                           //  .
      assert (n1 > 2);

      if ((CBNL)p2h < 0)
        p2h = ~p2h + ((p2l = -(CBNL)p2l) == 0);
      assert (p2h <= (unsigned CBNL)(CBNL_MIN) && (p2h | p2l) > 0);

//               0.
//         -CBNL_MIN,0    .

      CBNC nb2 = (int)_ulzcntCBNL (p2h) - 1;    //   .
      if (nb2 < 0) nb2 = 0;                     //  -CBNL_MIN,0.
      assert ((unsigned CBNC)nb2 < BITS);       //   .
      p2h = _ushldCBNL (p2l, p2h, nb2);         //   .
      p2l = _ushlCBNL (p2l, nb2);               //   .
      assert (p2h >= (((unsigned CBNL)1) << (BITS-2)));

//              ,
//             .
//          ,    
//       .

      *p = (CBNL)n1; p += n1;                   //  n1 - n2 + 2.
      *p-- = 0;                                 //   p.

      CBNC nb = nb2 - nb1;                      //   .
      if (nb < 0) {                             //    ,
        *p-- = 0; nb += BITS;                   //    .
      }                                         //  .
      unsigned CBNL mask = ((unsigned CBNL)1) << nb;
      assert ((unsigned CBNC)nb < BITS);        //   .

//               0.

      unsigned CBNL p1l = p1 [--n1];            //   .
      unsigned CBNL p1n = 0;                    //   .
      if (nb1 > 0)                              //    
      {                                         //   0-.
        p1n = p1 [--n1];                        //   .
        p1h = _ushldCBNL (p1l, p1h, nb1);       //    ,
        p1l = _ushldCBNL (p1n, p1l, nb1);       //   
        p1n = _ushlCBNL (p1n, nb1);             //     .
        nb1 -= BITS;
      }
      assert (p1h >= (((unsigned CBNL)1) << (BITS-2)));

//             .

      unsigned CBNL pn = 0;                     //   .
      for (;;)                                  //    .
      {                                         //    ,
        unsigned CBNL pnh, pnl;                 //    
        _sbbCBNL (_subCBNL (p1l, p2l, &pnl), p1h, p2h, &pnh);
        if ((CBNL)pnh >= 0) p1h = pnh; p1l = (CBNL)pnh >= 0? pnl: p1l;
        pn += ((CBNL)pnh >= 0)? mask: 0;        //   .
        if (++nb1 > 0)                          //  .
        {
          if (--n1 == 0) break;                 //   .
          p1n = p1 [n1]; nb1 -= BITS;           //   .
        }
        p1h = _ushld1CBNL (p1l, p1h);           //   .
        p1l = _ushld1CBNL (p1n, p1l);
        p1n += p1n;
        if (!(mask >>= 1))                      //   .
        {                                       //   .
          *p-- = pn; pn = 0;                    //   .
          mask = ((unsigned CBNL)1) << (BITS-1);//  .
        }
      }                                         //    .

//            .

      while ((p2l = _ushrd1CBNL (p2l, p2h),
              p2h >>= 1, mask >>= 1) != 0)      //    .
      {                                         //    ,
        unsigned CBNL pnh, pnl;                 //    
        _sbbCBNL (_subCBNL (p1l, p2l, &pnl), p1h, p2h, &pnh);
        if ((CBNL)pnh >= 0) p1h = pnh; p1l = (CBNL)pnh >= 0? pnl: p1l;
        pn += ((CBNL)pnh >= 0)? mask: 0;        //   .
      }                                         //    .
      *p-- = pn;                                //   .

      assert ((CBNL)p1h >= 0);                  //  .
      if (p1 [0] < 0) {                         //   .
        p1h = ~p1h + ((p1l = -(CBNL)p1l) == 0);
      }
      p1 [0] = 1 + ((CBNL)p1h != ((CBNL)p1l >> (BITS-1)));
      p1 [1] = p1l; p1[2] = p1h;                //  .
      assert (cBigNumberIsFit (p1));            //  .
      break; /* switch */
    }                                           //   
    p2h = p2l;                                  //  .

//            
//      ,   .

    default: /* n2 == 1 */                      //  ,
                                                //  .
#endif//_CBIGNUM_SMALL_DIV
      assert (n1 > 1);
      unsigned CBNL p1l = 0;                    //   .

      if ((CBNL)p2h < 0) p2h = -(CBNL)p2h;      //  .
      assert (p2h <= (unsigned CBNL)(CBNL_MIN) && p2h > 0);

//               0.
//         -CBNL_MIN,    .

      CBNC nb2 = (int)_ulzcntCBNL (p2h) - 1;    //   .
      if (nb2 < 0) nb2 = 0;                     //  -CBNL_MIN.
      assert ((unsigned CBNC)nb2 < BITS);       //   .

//              ,
//             .
//          ,    
//       .

      *p = (CBNL)(n1 + 1); p += (n1 + 1);       //  n1 - n2 + 2.
      *p-- = 0;                                 //   p.

//             
//            .

#if defined(_CBIGNUM_HARDWARE_DIV) && defined(_udivdCBNL)

//          ,    ,
//          .

    if (n1 > 2 || nb2 >= nb1)
    {
#endif//_udivdCBNL

      CBNC nb = nb2 - nb1;                      //   .
      if (nb < 0) {                             //    ,
        *p-- = 0; nb += BITS;                   //    .
      }                                         //  .
      unsigned CBNL mask = ((unsigned CBNL)1) << nb;
      assert ((unsigned CBNC)nb < BITS);        //   .

//          .

      if (nb1 > 0)                              //    
      {                                         //   0-.
        p1l = p1 [--n1];                        //   .
        p1h = _ushldCBNL (p1l, p1h, nb1);       //    
        p1l = _ushlCBNL (p1l, nb1);             //     .
        nb1 -= BITS;
      }
      assert (p1h >= (((unsigned CBNL)1) << (BITS-2)));
      p2h <<= nb2;                              //  .
      assert (p2h >= (((unsigned CBNL)1) << (BITS-2)));

//             .

      unsigned CBNL pn = 0;                     //   .
      for (;;)                                  //    .
      {
        CBNL pnh = p1h - p2h;                   //    ,
        if (pnh >= 0) p1h = pnh;                //    
        pn += (pnh >= 0)? mask: 0;              //   .
        if (++nb1 > 0)                          //  .
        {
#if defined(_CBIGNUM_HARDWARE_DIV) && defined(_udivdCBNL)
          p1l = p1 [--n1]; nb1 -= BITS;         //   .
#else //_udivdCBNL
          if (--n1 == 0) break;                 //   .
          p1l = p1 [n1]; nb1 -= BITS;           //   .
#endif//_udivdCBNL
        }
        p1h = _ushld1CBNL (p1l, p1h);           //   .
        p1l += p1l;
        if (!(mask >>= 1))                      //   .
        {                                       //   .
          *p-- = pn; pn = 0;                    //   .
#if defined(_CBIGNUM_HARDWARE_DIV) && defined(_udivdCBNL)
          if (n1 <= 1) break;                   //   .
#endif//_udivdCBNL
          mask = ((unsigned CBNL)1) << (BITS-1);//  .
        }
      }                                         //    .
#if defined(_CBIGNUM_HARDWARE_DIV) && defined(_udivdCBNL)
      nb1 += BITS;
      p1l = _ushrdCBNL (p1l, p1h, nb1);         //   .
      p1h = _ushrCBNL (p1h, nb1);
      p2h = _ushrCBNL (p2h, nb2);               //  .
    }
    else { p1l = p1 [1]; *p-- = 0; }            //   .

//          .

      assert (p1h < p2h);                       //  .
      *p-- = _udivdCBNL (p1l, p1h, p2h, (unsigned CBNL*)EXPTRBASE(p1) + 1);
      assert (p1 [1] >= 0);                      //   .
      if (p1 [0] < 0) p1 [1] = -p1 [1];         //   .

#else //_udivdCBNL 

//           .

#ifdef  _CBIGNUM_HARDWARE_DIV
      if (nb2 >= _CBNL_HARDDIV_BITS)            //   
      {                                         //   0-.
        p2h >>= nb2;                            //  .
#ifdef  _CBIGNUM_REVERSE_MOD
        unsigned CBNL pl = p1h / p2h;           // .
        pn |= pl; p1h -= pl * p2h;              //   .
#else //_CBIGNUM_REVERSE_MOD
        pn |= p1h / p2h; p1h %= p2h;            //   .
#endif//_CBIGNUM_REVERSE_MOD
      }
      else                                      //  .
#endif//_CBIGNUM_HARDWARE_DIV
      while ((p2h >>= 1, mask >>= 1) != 0)      //    .
      {
        CBNL pnh = p1h - p2h;                   //    ,
        if (pnh >= 0) p1h = pnh;                //    
        pn += (pnh >= 0)? mask: 0;              //   .
      }                                         //    .
      *p-- = pn;                                //   .

      assert ((CBNL)p1h >= 0);                  //  .
      if (p1 [0] >= 0) p1 [1] = p1h;            //  .
      else             p1 [1] = -(CBNL)p1h;     //   .

#endif//_udivdCBNL

      p1 [0] = 1;                               //    .
    }

    cBigNumberFit (p);                          //  .
    assert (p [(size_t)(*p)] >= 0);             //  .
    if (signquot < 0) cBigNumberNeg (p, p);     //   .
  }
#endif//_CBIGNUM_SMALL_DIV
}

//================================================
//        .
//================================================

//           .
//      ,       ,
//             0.
//            ,
//        cBigNumberTab.
//
//           
//       ,     .
//           .
//           .
//         0,   ,   .
//
//         .
//         .

void    cBigNumberMModShlTab (                  //  p1 %= p2<< k2*BITS.
                        EXPTR(CBNL) p1,         // ,  .
                const   CBPTR(CBNL) p2,         //    .
                        size_t      k2          //   .
        )                                       // p1, p2   .
{
  assert (cBigNumberIsFit (p1));                //  .
  assert (p1 != p2);                            //  .
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .
  size_t n = n2 + k2;                           //    .
  if (n > n1) n = n1;                           //   .
  n = n1 - n + 1 + k2;                          //  .

  if (n2 >= cBigNumberSkipLow0 (p2))            //   0- 
  {                                             //    0.
    CBNL p2h = p2 [n2];                         //   .
    assert ((p1 [n1] ^ p2h) >= 0);              //  .
    CBNL lt = (p2h < 0) * 2 - 1;                //   
                                                //   .
                                                // (p1  p2 >= 0)? -1: 1
    p2h ^= (p2h >> (BITS-1));                   //   p2 < 0.
    size_t nn2 = n + n2;                        //   
    p2h = ((CBNL)1) << (_ulzcntCBNL(p2h) - 1);  //      1.
    n2 += 2;                                    //    .

    do                                          //   .
    {
      p2 += n2 * BITS; --n;                     //    .
      unsigned CBNL mask = ((unsigned CBNL)1) << (BITS-1);
                                                //  .
      do                                        //   .
      {                                         //   
        p2 -= n2;                               //     .
        CBNL diff = nn2 - ((unsigned CBNL)p2h >= mask) - n1;
        if (diff <= 0 && (diff < 0 ||           //    
        _cBigNumberCompHigh (p1, p2, n) != lt)) //  ,
        {                                       //   .
          assert (diff < 0 ? p1 [n1] == p2 [(size_t)(*p2) + 1] : 1);
          //   _cBigNumberMSubD()   .
          //        
          //   ,    .
          //    cBigNumberTab()   
          //       1,   .
          n1 = _cBigNumberMSubD (p1, p2, n);    //  .
          p1 [0] = (CBNL) n1;                   //  .
        }
      }
      while ((mask >>= 1) != 0);                //    .
      --nn2;                                    //  .
    }
    while (n > k2);                             //    .

    assert ((p1 [(size_t)(*p1)] ^ lt) < 0 ||    //   
            (p1 [(size_t)(*p1)] + *p1) == 1);   //   0.
//  assert (cBigNumberComp (p1, p2) == lt);     //   .
    assert (cBigNumberIsFit (p1));              //  .
  }
  else                                          //  0.
  {                                             //    0
    cBigNumberDiv0();                           // ,  
  }                                             //   .

#ifndef _CBIGNUM_MT
  _cBigNumberSkip = 1;                          //   0-.
#endif//_CBIGNUM_MT
}

#ifdef  _CBNL_TAB_FULL

//            .
//
//              
//             .
//
//              ,
//             .
//           ,  
//       ,       .

void    cBigNumberMModShlTab2 (                 //  p1 %= p2<< k2*BITS.
                        EXPTR(CBNL) p1,         // ,  .
                const   CBPTR(CBNL) p2,         //    .
                        size_t      k2          //   .
        )                                       // p1, p2   .
{
  assert (cBigNumberIsFit (p1));                //  .
  assert (p1 != p2);                            //  .
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .
  size_t n = n2 + k2;                           //    .
  if (n > n1) n = n1;                           //   .
  n = n1 - n + 1 + k2;                          //  .

  if (n2 >= cBigNumberSkipLow0 (p2))            //   0- 
  {                                             //    0.
    CBNL p2h = p2 [n2];                         //   .
    assert ((p1 [n1] ^ p2h) >= 0);              //  .
    CBNL lt = (p2h < 0) * 2 - 1;                //   
                                                //   .
                                                // (p1  p2 >= 0)? -1: 1
    p2h ^= (p2h >> (BITS-1));                   //   p2 < 0.
    size_t nn2 = n + n2;                        //   
    p2h = ((CBNL)1) << (_ulzcntCBNL(p2h) - 1);  //      1.
    n2 += 2;                                    //    .
    p2 += n2 * BITS/2;                          //   .

    do                                          //   .
    {
      const CBNL* pp2 = (const CBNL*)           //    p2.
                        ((const int*)(CBPTRBASE(p2)) - 1);
      --n;                                      //  pp2.
      unsigned CBNL mask = ((unsigned CBNL)1) << (BITS-1);
                                                //  .
      do                                        //    .
      {                                         //   
        pp2 -= n2;                              //     .
        CBNL diff = nn2 - ((unsigned CBNL)p2h >= mask) - n1;
        if (diff <= 0 && (diff < 0 ||           //    
        _cBigNumberCompHigh (p1, pp2, n) != lt))//  ,
        {                                       //   .
          n1 = _cBigNumberMSubD (p1, pp2, n);   //  .
          p1 [0] = (CBNL) n1;                   //  .
        }
      }
      while ((unsigned)(mask >>= 1) == 0);      //    .

      pp2 = CBPTRBASE(p2);                      //   p2.
      do                                        //    .
      {                                         //   
        pp2 -= n2;                              //     .
        CBNL diff = nn2 - ((unsigned CBNL)p2h >= mask) - n1;
        if (diff <= 0 && (diff < 0 ||           //    
        _cBigNumberCompHigh (p1, pp2, n) != lt))//  ,
        {                                       //   .
          assert (diff < 0 ? p1 [n1] == pp2 [(size_t)(*pp2) + 1] : 1);
          //   _cBigNumberMSubD()   .
          //        
          //   ,    .
          //    cBigNumberTab()   
          //       1,   .
          n1 = _cBigNumberMSubD (p1, pp2, n);    //  .
          p1 [0] = (CBNL) n1;                   //  .
        }
      }
      while ((mask >>= 1) != 0);                //    .
      --nn2;                                    //  .
    }
    while (n > k2);                             //    .

    assert ((p1 [(size_t)(*p1)] ^ lt) < 0 ||    //   
            (p1 [(size_t)(*p1)] + *p1) == 1);   //   0.
//  assert (cBigNumberComp (p1, p2) == lt);     //   .
    assert (cBigNumberIsFit (p1));              //  .
  }
  else                                          //  0.
  {                                             //    0
    cBigNumberDiv0();                           // ,  
  }                                             //   .

#ifndef _CBIGNUM_MT
  _cBigNumberSkip = 1;                          //   0-.
#endif//_CBIGNUM_MT
}

#endif//_CBNL_TAB_FULL

//              
//            .
//         ,      
//      ,   ,    .
//
//           
//       ,     .
//           .
//           .
//         0,   ,   .
//
//         .
//         .

void    cBigNumberMMod (                        //  p1 %= p2.
                        EXPTR(CBNL) p1,         // ,  
                                                //    *p1 + 3 -
                const   CBPTR(CBNL) p2          // . (p1 [*p1] == 0);
        )                                       // p1, p2  .
{
  assert (cBigNumberIsFit (p1));                //  .
  size_t n1 = (size_t)(*p1);                    //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .

//           ,   .

#ifdef  _CBIGNUM_SMALL_DIV
  unsigned CBNL p2h = 0, p2l = 0;               //    0.
  if (n2 - 1 <= _CBIGNUM_SMALL_DIV - 1) { p2l = p2 [1];
                                          p2h = p2 [n2]; }

//            
//          ,
//         _CBIGNUM_SMALL_DIV .

  if ((p2h | p2l) == 0)                         //    
  {                                             //   .
#endif//_CBIGNUM_SMALL_DIV
    cBigTemp cBigBuf2;                          //   .
#ifdef _CBIGNUM_SUBMUL_DIV
    cBigBuf2.checkexpand ((size_t)(n2 + 3));
#else //_CBIGNUM_SUBMUL_DIV
#ifdef  _CBIGNUM_SHIFTTAB_DIV
    CBNL nt = (CBNL)((n2 - n1 + _CBNL_TAB_MIN - 1) & (n2 - _CBNL_TAB_MAX));
    cBigBuf2.checkexpand ((size_t)((nt >= 0)? (n2 + 3):
#ifdef  _CBNL_TAB_FULL
                       (n2 > _CBNL_TAB_FULL)? (n2 + 3) * BITS/2 + 1:
#endif//_CBNL_TAB_FULL
                                              (n2 + 3) * BITS + 1));
#else //_CBIGNUM_SHIFTTAB_DIV
    cBigBuf2.checkexpand ((size_t)(n2 + 3));
#endif//_CBIGNUM_SHIFTTAB_DIV
#endif//_CBIGNUM_SUBMUL_DIV
    EXPTR(CBNL) pp2 = EXPTRTYPE(cBigBuf2);      //   .

//              0-.
//        0,    0 .

    size_t k2 = cBigNumberCopySkipLow0 (p2, pp2);

#ifndef _CBIGNUM_SUBMUL_DIV

//           .
//      CBPTRBASE      p2.

    if ((p1 [n1] ^ CBPTRBASE(p2)[n2]) < 0) cBigNumberNeg (pp2, pp2);

//          .

#ifdef  _CBIGNUM_SHIFTTAB_DIV
    if (nt < 0)
    {
//             
//          .
#ifdef  _CBNL_TAB_FULL
      if (n2 > _CBNL_TAB_FULL)
      {
        _cBigNumberTab (pp2, BITS/2);           //   .
        cBigNumberMModShlTab2 (p1, pp2, k2);    // .
      }
      else
#endif//_CBNL_TAB_FULL
      {
        cBigNumberTab (pp2);                    //   .
        cBigNumberMModShlTab (p1, pp2, k2);     // .
      }
      return;
    }
#endif//_CBIGNUM_SHIFTTAB_DIV

//       ,    .

    n2 = (size_t)(*pp2);                        //  .
    if (n2 == 0)                                //  0.
    {                                           //    0
      cBigNumberDiv0();                         // ,  
      return;                                   //   .
    }
    assert (cBigNumberIsFit (pp2));             //  .

    size_t n = n2 + k2;                         //    .
    if (n > n1) return;                         //   ,
                                                //    .
    n = n1 - n2 + 1;                            //  .

    assert ((p1 [n1] ^ pp2 [n2]) >= 0);         //   .
    CBNL lt = (pp2 [n2] < 0) * 2 - 1;           //   
                                                //   
                                                // (p1  pp2 >= 0)? -1: 1
    do                                          //   .
    {
      cBigNumberMShlD (pp2); --n;               //    .
      unsigned CBNL mask = ((unsigned CBNL)1) << (BITS-1);
                                                //  .
      do                                        //   .
      {
        CBNL diff = (CBNL)cBigNumberMDiv2D (pp2)//    .
                  + (CBNL)n - (CBNL)n1;         //  .
        if (diff <= 0 && (diff < 0 ||           //    
        _cBigNumberCompHigh (p1, pp2, n) != lt))//  ,
        {                                       //   .
          n1 = cBigNumberMSubD (p1, pp2, n);    //  .
        }
      }
      while ((mask >>= 1) != 0);                //    .
    }
    while (n > k2);                             //    .

    assert ((p1 [(size_t)(*p1)] ^ lt) < 0 ||    //   
            (p1 [(size_t)(*p1)] + *p1) == 1);   //   0.

#else //_CBIGNUM_SUBMUL_DIV

//         .

    #undef  CPRG
    #define CPRG(a)

    n2 = (size_t)(*pp2);                        //  .
    if (n2 == 0)                                //  0.
    {                                           //    0
      cBigNumberDiv0();                         // ,  
      return;                                   //   .
    }
    assert (cBigNumberIsFit (pp2));             //  .

//          .

    unsigned CBNL p2p = pp2 [n2];               //   .
    if ((CBNL)p2p < 0) {
      n2 = cBigNumberNeg (pp2, pp2);            //   
      p2p = pp2 [n2];                           //    .
    }                                           //   0-.
    void _CBNL_C (*pfNumberMSubM)(EXPTR(CBNL), const CBPTR(CBNL), size_t);
    if (p2p != 0) {                             //   0-
      pfNumberMSubM = cBigNumberMSubM;          //    
    } else {                                    //   .
      pfNumberMSubM = cBigNumberMSubMM; p2p = pp2 [--n2]; *pp2 = (CBNL)n2;
    }
    assert (pp2 [n2] != 0 && n2 > 0);

//      ,     .

    CBNL signrem = p1 [n1];                     //  /.
    if (n1) n1 -= (signrem == 0);               //    0-.
    if (n2 + k2 > n1) return;                   //   .
    assert (p1 [n1] != 0 && n1 > 0);

//         (    ).

    if (signrem < 0) {
      cBigNumberNeg (p1, p1);                   //   .
    }

//             
//       .    cBigNumberMSubMulM.

    *p1 = n1 + 2; p1 [n1 + 2] = p1 [n1 + 1] = 0;

//            .

    if (n2 > 1)                                 //  .
    {
      CBNC nb2 = (CBNC)_ulzcntCBNL (p2p);       //   0-.

//             1  
//       . p2p   .

      p2p = _ushldCBNL (pp2 [n2 - 1], p2p, nb2) + 1;

//       .

      n2 = n1 - n2; assert (n2 >= k2);          //   ().
      unsigned CBNL p1l = p1 [n1 - 1];          //   ,
      unsigned CBNL p1h = p1 [n1];              //   
                                                //  .
//       .

      CBNC nb1 = (CBNC)_ulzcntCBNL (p1h);       //   0-
      if (nb1 < nb2) { unsigned CBNL pa;        //   .
        assert (nb2 > 0);
        p1l = _ushrdCBNL (p1l, p1h, BITS - nb2);//    
        p1h = _ushrCBNL (p1h, BITS - nb2);      //    
                                                //   .
        if (p2p) p1h = _udivdCBNL (p1l, p1h, p2p, &pa);
        CPRG('\n'); CPRG((CBNL)n1); CPRG(' '); CPRG((CBNL)n2);
        CPRG(' '); CPRG((CBNL)nb1); CPRG(' '); CPRG((CBNL)nb2);
        CPRG(' '); CPRG((CBNL)p1h);
        cBigNumberMSubMulM (p1, pp2, p1h, n2);  //  .
        p1l = p1 [n1 - 1]; p1h = p1 [n1];       //   .
      }

//              
//           ,    
//       .      .

      for (;; p1l = p1 [n1 - 1], p1h = p1 [n1]) //    
      {                                         //   .
        nb1 = (CBNC)_ulzcntCBNL (p1h);          //   0-.
        CPRG('\n'); CPRG((CBNL)n1); CPRG(' '); CPRG((CBNL)n2);
        CPRG(' '); CPRG((CBNL)nb1); CPRG(' '); CPRG((CBNL)nb2);
        if (nb1 < nb2 || p2p <= (               // Compare number of bits.
            p1h =_ushldCBNL (p1l, p1h, nb2))    //    .
            && p2p)
        { CPRG(" 1");                           //    ,
          (*pfNumberMSubM)(p1, pp2, n2);        //   .
          continue;
        }                                       //    
        if (n2 == k2) break;                    //    , 
                                                //     .
        if (p2p) { unsigned CBNL pa;            //    p1h?
          p1l = _ushldCBNL ((n1 > 2 ? p1 [n1 - 2] : 0), p1l, nb2);
          p1h = _udivdCBNL (p1l, p1h, p2p, &pa);
        }                                       //   .
        n2--; CPRG(' '); CPRG((CBNL)p1h);       //   ,
        cBigNumberMSubMulM (p1, pp2, p1h, n2);  //  .

//              
//       ,  nb2 = 0.       
//           .

        if (p1 [n1--] != 0) { CPRG("+1");       //     0,
          (*pfNumberMSubM)(p1, pp2, n2);        //   .
          assert (p1 [n1 + 1] == 0);            //    .
        }
      }                                         //   .

//         ,     
//            .

      n2 = n1 - n2;                             //  n2  
      assert (n1 == n2 + k2 && n2 > 0);         //    pp2.
      do continue; while ((p1h = p1 [n2 + k2]) == (p2p = pp2 [n2]) && --n2);
      if (p1h >= p2p) { CPRG("+1");             //    ,
        (*pfNumberMSubM)(p1, pp2, k2);          //   .
      }
    }
    else if (n1 - 1 > k2) // n2 == 1            //  ,
    {                                           //  .
      n2 = n1 - 1;                              //   ().
      do                                        //   .
      {                                         //   ,
        unsigned CBNL p1h = p1 [n2 + 1];        //   
        CPRG('\n'); CPRG((CBNL)n2);
        if (p2p <= p1h) {                       //    ,
          p1h /= p2p;                           //    
        } else { unsigned CBNL pa;              //     
          p1h = _udivdCBNL (p1 [n2], p1h, p2p, &pa);
          n2--;                                 //   .
        }
        CPRG(' '); CPRG((CBNL)p1h);
        cBigNumberMSubMulM (p1, pp2, p1h, n2);  //  .
      }
      while (n2 > k2);                          //   .
    }
    else // n1 == k2 + 1 && n2 == 1             //   .
    {
      p1 [n1] %= p2p;                           //  .
    }

    //  .

    while (p1 [n1] == 0 && n1 > 1) --n1;        //   0-.
    p1 [0] = n1 + (p1 [n1] < 0);                //    .
    if (signrem < 0) cBigNumberNeg (p1, p1);    //   .

#endif//_CBIGNUM_SUBMUL_DIV

    assert (cBigNumberIsFit (p1));              //  .

#ifdef  _CBIGNUM_SMALL_DIV
    return;
  }

//           
//       .

  unsigned CBNL p1h = p1 [n1];                  //   .

//        ,    .

  if (n1 <= n2)                                 //    .
  {
//         ,    ,
//         .

CompareSize:
    if (n1 == n2)                               //  .

//            .

#if _CBIGNUM_SMALL_DIV > 1
    switch (n2)
#endif//_CBIGNUM_SMALL_DIV
    {
#if _CBIGNUM_SMALL_DIV > 1
    case 2:                                     //  ,
    {                                           //  .
      assert (n1 == 2 && n2 == 2);

      if ((CBNL)p2h == ((CBNL)p2l >> (BITS-1))) //    -
        goto LongerDividend;                    //   .

      unsigned CBNL p1l = p1 [1];               //   .

//        .

      if ((CBNL)p1h < 0) {
        p1h = ~p1h + ((p1l = -(CBNL)p1l) == 0); //  .
        if ((CBNL)p1h < 0) goto LongerDividend; //  -CBNL_MIN,0 ,
      }                                         //   
      assert ((CBNL)p1h >= 0);                  //  .

      if ((CBNL)p2h < 0)
        p2h = ~p2h + ((p2l = -(CBNL)p2l) == 0); //  .
      assert (p2h <= (unsigned CBNL)(CBNL_MIN) && (p2h | p2l) > 0);

//           .
//         BITS-1, .. p1h    0.

      CBNC nb = (int)_ulzcntCBNL (p2h) - (int)_ulzcntCBNL (p1h);
      if (nb >= 0)                              //    
      {                                         // ,  .
        assert ((unsigned CBNC)nb < BITS);      //   .
        p2h = _ushldCBNL (p2l, p2h, nb);        //  .
        p2l = _ushlCBNL (p2l, nb);
        do                                      //   .
        {                                       //    ,
          unsigned CBNL pnh, pnl;               //   .
          _sbbCBNL (_subCBNL (p1l, p2l, &pnl), p1h, p2h, &pnh);
          if ((CBNL)pnh >= 0) p1h = pnh; p1l = (CBNL)pnh >= 0? pnl: p1l;
        }
        while ((p2l = _ushrd1CBNL (p2l, p2h),
                p2h >>= 1, --nb) >= 0);         //    .
      }

      assert ((CBNL)p1h >= 0);                  //  .
      if (p1 [2] < 0)                           //   .
        p1h = ~p1h + ((p1l = -(CBNL)p1l) == 0);
      p1 [0] = 1 + ((CBNL)p1h != ((CBNL)p1l >> (BITS-1)));
      p1 [1] = p1l; p1 [2] = p1h;               //  .
      assert (cBigNumberIsFit (p1));            //  .
      break; /* switch */
    }

//          ,   .

    default: /* n1 == 1 */                      //  ,
                                                //  .
#endif//_CBIGNUM_SMALL_DIV
      assert (n1 == 1 && n2 == 1);

//        .

      if ((CBNL)p1h < 0) p1h = -(CBNL)p1h;      //  .
      assert (p1h <= (unsigned CBNL)(CBNL_MIN));

      if ((CBNL)p2h < 0) p2h = -(CBNL)p2h;      //  .
      assert (p2h <= (unsigned CBNL)(CBNL_MIN) && p2h != 0);

#ifdef  _CBIGNUM_HARDWARE_DIV
      p1h %= p2h;                               // .
#else //_CBIGNUM_HARDWARE_DIV

//           .
//         BITS-1, .. p2h   0.

      CBNC nb = (int)_ulzcntCBNL (p2h) - (int)_ulzcntCBNL (p1h);
      if (nb >= 0)                              //    
      {                                         // ,  .
        assert ((unsigned CBNC)nb < BITS);      //   .
        p2h <<= nb;                             //  .
        do                                      //   .
        {
          CBNL pnh = p1h - p2h;                 //    ,
          if (pnh >= 0) p1h = pnh;              //   .
        }
        while ((p2h >>= 1, --nb) >= 0);         //    .
      }
#endif//_CBIGNUM_HARDWARE_DIV

      assert (p1h <= (unsigned CBNL)(CBNL_MIN));
      if (p1 [1] >= 0) p1 [1] = p1h;            //  .
      else             p1 [1] = -(CBNL)p1h;     //   .
    }
    else if ((CBNL)p2h == ((CBNL)p2l >> (BITS-1)) ||
             p2h == 0 && p2l == (((unsigned CBNL)1) << (BITS-1)))
    {                                           //    
      p2h = p2l; --n2; goto CompareSize;        //    
    }                                           //    .
  }

//         ,    
//        .        
//      ,       .

  else /* n1 > n2 */                            //   .
  {
#if _CBIGNUM_SMALL_DIV > 1
LongerDividend:
#endif//_CBIGNUM_SMALL_DIV
    if ((CBNL)p1h < 0) {                        //   
      p1 [0] = p1h;                             //    
      size_t n = 0;                             //   .
      do ++n; while ((p1 [n] = p1h = -p1 [n]) == 0); ++n;
      if (n <= n1) do p1 [n] = p1h = ~p1 [n]; while (++n <= n1);
      else if ((CBNL)p1h < 0) { p1h = 0; ++n1; }//    
    }                                           // -CBNL_MIN,  
    assert ((CBNL)p1h >= 0);                    //  .

//               0.

    CBNC nb1 = (int)_ulzcntCBNL (p1h) - 1;      //   .
    assert ((unsigned CBNC)nb1 < BITS);         //   .

//            .

#if _CBIGNUM_SMALL_DIV > 1
    switch (n2)
#endif//_CBIGNUM_SMALL_DIV
    {
#if _CBIGNUM_SMALL_DIV > 1
    case 2:                                     //  ,
    if ((CBNL)p2h != ((CBNL)p2l >> (BITS-1)))   //  ,
    {                                           //  .
      assert (n1 > 2);

      if ((CBNL)p2h < 0)
        p2h = ~p2h + ((p2l = -(CBNL)p2l) == 0);
      assert (p2h <= (unsigned CBNL)(CBNL_MIN) && (p2h | p2l) > 0);

//               0.
//         -CBNL_MIN,0    .

      CBNC nb2 = (int)_ulzcntCBNL (p2h) - 1;    //   .
      if (nb2 < 0) nb2 = 0;                     //  -CBNL_MIN,0.
      assert ((unsigned CBNC)nb2 < BITS);       //   .
      p2h = _ushldCBNL (p2l, p2h, nb2);         //   .
      p2l = _ushlCBNL (p2l, nb2);               //   .
      assert (p2h >= (((unsigned CBNL)1) << (BITS-2)));

//               0.

      unsigned CBNL p1l = p1 [--n1];            //   .
      unsigned CBNL p1n = 0;                    //   .
      if (nb1 > 0)                              //    
      {                                         //   0-.
        p1n = p1 [--n1];                        //   .
        p1h = _ushldCBNL (p1l, p1h, nb1);       //    ,
        p1l = _ushldCBNL (p1n, p1l, nb1);       //   
        p1n = _ushlCBNL (p1n, nb1);             //     .
        nb1 -= BITS;
      }
      assert (p1h >= (((unsigned CBNL)1) << (BITS-2)));

//        ().

      for (;;)                                  //   .
      {                                         //    ,
        unsigned CBNL pnh, pnl;                 //   .
        _sbbCBNL (_subCBNL (p1l, p2l, &pnl), p1h, p2h, &pnh);
        if ((CBNL)pnh >= 0) p1h = pnh; p1l = (CBNL)pnh >= 0? pnl: p1l;
        if (++nb1 > 0)                          //  .
        {
          if (--n1 == 0) break;                 //   .
          p1n = p1 [n1]; nb1 -= BITS;           //   .
        }
        p1h = _ushld1CBNL (p1l, p1h);           //   .
        p1l = _ushld1CBNL (p1n, p1l);
        p1n += p1n;
      }                                         //    .

//            .

      while ((p2l = _ushrd1CBNL (p2l, p2h),
              p2h >>= 1, --nb2) >= 0)           //   .
      {                                         //    ,
        unsigned CBNL pnh, pnl;                 //   .
        _sbbCBNL (_subCBNL (p1l, p2l, &pnl), p1h, p2h, &pnh);
        if ((CBNL)pnh >= 0) p1h = pnh; p1l = (CBNL)pnh >= 0? pnl: p1l;
      }                                         //    .

      assert ((CBNL)p1h >= 0);                  //  .
      if (p1 [0] < 0) {                         //   .
        p1h = ~p1h + ((p1l = -(CBNL)p1l) == 0);
      }
      p1 [0] = 1 + ((CBNL)p1h != ((CBNL)p1l >> (BITS-1)));
      p1 [1] = p1l; p1[2] = p1h;                //  .
      assert (cBigNumberIsFit (p1));            //  .
      break; /* switch */
    }                                           //   
    p2h = p2l;                                  //  .

//            
//      ,   .

    default: /* n2 == 1 */                      //  ,
                                                //  .
#endif//_CBIGNUM_SMALL_DIV
      assert (n1 > 1);
      unsigned CBNL p1l = 0;                    //   .

      if ((CBNL)p2h < 0) p2h = -(CBNL)p2h;      //  .
      assert (p2h <= (unsigned CBNL)(CBNL_MIN) && p2h > 0);

//               0.
//         -CBNL_MIN,    .

      CBNC nb2 = (int)_ulzcntCBNL (p2h) - 1;    //   .
      if (nb2 < 0) nb2 = 0;                     //  -CBNL_MIN.
      assert ((unsigned CBNC)nb2 < BITS);       //   .

//             
//            .

#if defined(_CBIGNUM_HARDWARE_DIV) && defined(_umoddCBNL)

//          ,    ,
//          .

    if (n1 > 2 || nb2 >= nb1)
    {
#endif//_umoddCBNL

      CBNC nb = nb2 - nb1;                      //   .
      if (nb < 0) nb += BITS;
      assert ((unsigned CBNC)nb < BITS);        //   .

//          .

      if (nb1 > 0)                              //    
      {                                         //   0-.
        p1l = p1 [--n1];                        //   .
        p1h = _ushldCBNL (p1l, p1h, nb1);       //    
        p1l = _ushlCBNL (p1l, nb1);             //     .
        nb1 -= BITS;
      }
      assert (p1h >= (((unsigned CBNL)1) << (BITS-2)));
      p2h <<= nb2;                              //  .
      assert (p2h >= (((unsigned CBNL)1) << (BITS-2)));

//        ().

      for (;;)                                  //   .
      {
        CBNL pnh = p1h - p2h;                   //    ,
        if (pnh >= 0) p1h = pnh;                //   .
        if (++nb1 > 0)                          //  .
        {
#if defined(_CBIGNUM_HARDWARE_DIV) && defined(_umoddCBNL)
          p1l = p1 [--n1]; nb1 -= BITS;         //   .
#else //_umoddCBNL
          if (--n1 == 0) break;                 //   .
          p1l = p1 [n1]; nb1 -= BITS;           //   .
#endif//_umoddCBNL
        }
        p1h = _ushld1CBNL (p1l, p1h);           //   .
        p1l += p1l;
#if defined(_CBIGNUM_HARDWARE_DIV) && defined(_umoddCBNL)
        if (--nb < 0)                           //    
        {                                       //   ,
          if (n1 <= 1) break;                   //    .
          nb += BITS;
        }
#endif//_umoddCBNL
      }                                         //    .
#if defined(_CBIGNUM_HARDWARE_DIV) && defined(_umoddCBNL)
      nb1 += BITS;
      p1l = _ushrdCBNL (p1l, p1h, nb1);         //   .
      p1h = _ushrCBNL (p1h, nb1);
      p2h = _ushrCBNL (p2h, nb2);               //  .
    }
    else p1l = p1 [1];                          //   .

//          .

      assert (p1h < p2h);                       //  .
      p1 [1] = _umoddCBNL (p1l, p1h, p2h);      // .
      assert (p1 [1] >= 0);                     //   .
      if (p1 [0] < 0) p1 [1] = -p1 [1];         //   .

#else //_umoddCBNL 

//           .

#ifdef  _CBIGNUM_HARDWARE_DIV
      if (nb2 >= _CBNL_HARDDIV_BITS)            //   
      {                                         //   0-.
        p2h >>= nb2;                            //  .
        p1h %= p2h;                             // .
      }
      else                                      //  .
#endif//_CBIGNUM_HARDWARE_DIV
      while ((p2h >>= 1, --nb2) >= 0)           //   .
      {
        CBNL pnh = p1h - p2h;                   //    ,
        if (pnh >= 0) p1h = pnh;                //   .
      }                                         //    .

      assert ((CBNL)p1h >= 0);                  //  .
      if (p1 [0] >= 0) p1 [1] = p1h;            //  .
      else             p1 [1] = -(CBNL)p1h;     //   .

#endif//_umoddCBNL

      p1 [0] = 1;                               //    .
    }
  }
#endif//_CBIGNUM_SMALL_DIV
}

//================================================
//         .
//================================================

//            ,
//         ,      , 
//       .       
//             .
//      ,    p2     p1 
//       -1,0,1,      512 M.
//
//             
//       .

void    cBigNumberPow (                         //  p1   p2.
                        EXPTR(CBNL) p1,         //    
                                                //  *p + 3.
                const   CBPTR(CBNL) p2,         // .
                        EXPTR(CBNL) p           //   
                                                //  *p + 3.
        )                                       // p1,p2,p   .
{
  assert (p1 != p);                             //  .
  assert (p2 != p);                             //  .
  assert (p2 != p1);                            //  .
  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .

  p [0] = 1; p [1] = 1;                         //   1.

  if (CBPTRBASE(p2)[n2] < 0)                    //  ?
  {
    cBigNumberFit (p1);                         // .
    cBigNumberMModDiv (p, p1, p1);              //   1/p1 
    if (p1 [1] + (p2 [1] & 1) < 0) p1 [1] = 1;  // abs(1/p1)  p2 .
    p [1] = p1 [1];
    return;
  }
  assert (CBPTRBASE(p2)[n2] >= 0);              //  .

  n2 = cBigNumberWords (p2);                    //   .
  if (n2 != 0)                                  //     1?
  {
    p2++;                                       // .
    unsigned CBNL num = *p2++; --n2;            //   p2.
    unsigned CBNL mask = 1;                     //    num.
    for (;;)                                    //    p2.
    {
      if (num & mask)                           //   p2 .
        cBigNumberMul (p1, p, p);               //  .
      if (n2 == 0) {                            //   p2.
        if ((num >>= 1) == 0) break;            //  p2 .
      } else                                    //    p2.
        if ((mask <<= 1) == 0) {                //  num .
          num = *p2++; mask = 1; --n2;          //   p2.
        }
      cBigNumberMul (p1, p1, p1);               //  .
    }                                           //     p2.
  }
}

//              ,
//       . ,       ,
//              .
//            ,  
//               .
//
//          ( 0    0 ,
//         1).
//
//             
//       .

void    cBigNumberPowMod (                      //  p1   p2.
                        EXPTR(CBNL) p1,         //    
                                                //  max (*p, *p1 + 3).
                const   CBPTR(CBNL) p2,         // .
                const   CBPTR(CBNL) mod,        // .
                        EXPTR(CBNL) p           //   
                                                //  *mod * 2 + 3.
        )                                       // p2, mod  .
{
  assert (p1 != p);                             //  .
  assert (p2 != p);                             //  .
  assert (p2 != p1);                            //  .
  assert (mod != p);                            //  .
  assert (mod != p1);                           //  .

  p [0] = 1; p [1] = 1;                         //   1.

  if (p1 [(size_t)(*p1)] < 0)                   //  ?
  {
    cBigNumberNeg (p1, p1);                     //   .
    cBigNumberPowMod (p1, p2, mod, p);          // .
    if (p2 [1] & 1) cBigNumberNeg (p, p);       //   
    return;                                     //   .
  }
  assert (p1 [(size_t)(*p1)] >= 0);             //  .
  cBigNumberFit (p1);                           // .

  size_t n2 = (size_t)(*CBPTRBASE(p2));         //  .
  if (CBPTRBASE(p2)[n2] < 0)                    //  ?
  {
    cBigNumberMModDiv (p, p1, p1);              //   1/p1.
    p [1] = p1 [1]; cBigNumberMMod (p, mod);    //  .
    return;
  }
  assert (CBPTRBASE(p2)[n2] >= 0);              //  .
  p2++;                                         // .

  size_t nmod = (size_t)(*CBPTRBASE(mod));      //  .

//       ,     .

#ifdef  _CBIGNUM_SMALL_POWMOD
  unsigned CBNL pmh = 0;                        //    0.
  if (nmod == 1)                                //  .
  {
    pmh = CBPTRBASE(mod) [1];                   // .
    if ((CBNL)pmh < 0) pmh = -(CBNL)pmh;        //   
  }                                             //   0..-CBNL_MIN.

//               .

  if (pmh <= 1)                                 //  .
#endif//_CBIGNUM_SMALL_POWMOD

//           , 
//         _CBIGNUM_SMALL_DIV ,
//          _CBIGNUM_SUBMUL_DIV.

#ifndef _CBIGNUM_SUBMUL_DIV
#ifdef  _CBIGNUM_SMALL_DIV
  if (nmod > _CBIGNUM_SMALL_DIV)                //    .
#endif//_CBIGNUM_SMALL_DIV
  {
    cBigTemp cBigBuf3;                          //   .
    cBigBuf3.checkexpand (exmuladd (BITS, nmod, BITS * 3 + 1));
    EXPTR(CBNL) pmod = EXPTRTYPE(cBigBuf3);     //   .

//            
//       0-.   0,    0 .

    size_t kmod = cBigNumberCopySkipLow0 (mod, pmod);
    nmod = (size_t)(*pmod);                     //  .

//         0.

    if (nmod == 0) { cBigNumberDiv0(); return; }

//          
//          .

    if (pmod [nmod] < 0) nmod = cBigNumberNeg (pmod, pmod);
    cBigNumberTab (pmod);                       //   .

//       .   -  0   1,
//           0.

    p [1] = (nmod + kmod != 1 || pmod [nmod] != 1);

//       ,      .

    cBigNumberMModShlTab (p1, pmod, kmod);      //  .

//           .

    if (n2)                                     //    p2?
    {
      unsigned CBNL num = *p2++; --n2;          //   p2.
      unsigned CBNL mask = 1;                   //    num.
      for (;;)                                  //    p2.
      {
        if (num & mask)                         //   p2 .
        {
          cBigNumberMul (p1, p, p);             //  .
          cBigNumberMModShlTab (p, pmod, kmod); //  .
        }
        if (n2 == 0) {                          //   p2.
          if ((num >>= 1) == 0) break;          //  p2 .
        } else                                  //    p2.
          if ((mask <<= 1) == 0) {              //  num .
            num = *p2++; mask = 1; --n2;        //   p2.
          }
        cBigNumberMul (p1, p1, p1);             //  .
        cBigNumberMModShlTab (p1, pmod, kmod);  //   .
      }                                         //     p2.
    }
  }
#ifdef  _CBIGNUM_SMALL_DIV
  else                                          //    .
#endif//_CBIGNUM_SMALL_DIV
#endif//_CBIGNUM_SUBMUL_DIV
#if defined(_CBIGNUM_SUBMUL_DIV) || defined(_CBIGNUM_SMALL_DIV)
  {
//      ,    0   
//          0   1/-1.

#ifndef _CBIGNUM_SMALL_POWMOD
    unsigned CBNL
#endif
    pmh = CBPTRBASE(mod) [nmod];                //   .
#if defined(_CBIGNUM_SUBMUL_DIV) || _CBIGNUM_SMALL_DIV > 1
    for (;;)
    if (nmod > 1) {                             //  ?
      if ((CBNL)pmh != (mod [nmod - 1] >> (BITS-1))) break;
      pmh = mod [nmod - 1]; --nmod;             //   .
    } else {
#endif
      if (pmh == 0) { cBigNumberDiv0(); return; }
      p [1] = ((unsigned CBNL)(pmh + 1) > 2);   //   1  -1.
#if defined(_CBIGNUM_SUBMUL_DIV) || _CBIGNUM_SMALL_DIV > 1
      break;
    }
#endif

//       ,      .

    cBigNumberMMod (p1, mod);                  //  .

//           .

    if (n2)                                     //    p2?
    {
      unsigned CBNL num = *p2++; --n2;          //   p2.
      unsigned CBNL mask = 1;                   //    num.
      for (;;)                                  //    p2.
      {
        if (num & mask)                         //   p2 .
        {
          cBigNumberMul (p1, p, p);             //  .
          cBigNumberMMod (p, mod);              //  .
        }
        if (n2 == 0) {                          //   p2.
          if ((num >>= 1) == 0) break;          //  p2 .
        } else                                  //    p2.
          if ((mask <<= 1) == 0) {              //  num .
            num = *p2++; mask = 1; --n2;        //   p2.
          }
        cBigNumberMul (p1, p1, p1);             //  .
        cBigNumberMMod (p1, mod);               //   .
      }                                         //     p2.
    }
  }
#endif//_CBIGNUM_SUBMUL_DIV || _CBIGNUM_SMALL_DIV

#ifdef  _CBIGNUM_SMALL_POWMOD
  else// pmh > 1                                //   > 1.
  {
    assert (pmh > 1 && pmh <= (unsigned CBNL)(CBNL_MIN));

//       ,      ,   .

    cBigNumberMMod (p1, mod);                   //  .
    unsigned CBNL p1h = p1 [1];                 //  .
    unsigned CBNL ph = 1; /* (pmh > 1) */       //  .

//           .  2..-CBNL_MIN.

    if (n2)                                     //    p2?
    {
      unsigned CBNL num = *p2++; --n2;          //   p2.
      unsigned CBNL mask = 1;                   //    num.

//             
//      .  ,     
//     ,       .

#if defined(_CBIGNUM_HARDWARE_DIV) && defined(_umoddCBNL)
      {
        for (;;)                                //    p2.
        {
          if (num & mask)                       //   p2 .
          {
            unsigned CBNL pp;                   //    .
            ph = _umuldCBNL (p1h, ph, &pp);     //  .
            ph = _umoddCBNL (ph, pp, pmh);      //  .
          }
          if (n2 == 0) {                        //   p2.
            if ((num >>= 1) == 0) break;        //  p2 .
          } else                                //    p2.
            if ((mask <<= 1) == 0) {            //  num .
              num = *p2++; mask = 1; --n2;      //   p2.
            }
          {
            unsigned CBNL pp;                   //    .
            p1h = _umuldCBNL (p1h, p1h, &pp);   //  .
            p1h = _umoddCBNL (p1h, pp, pmh);    //   .
          }
        }                                       //     p2.
      }
#else //_umoddCBNL 

//             
//           .    
//           ,   
//       -CBNL_MIN,   cLongBits  1  0.
//        1..BITS-2.

      unsigned CBNC nb = BITS - (unsigned CBNC)cLongBits (pmh);

//        - ,   .
//         ,  .

#ifdef  _CBIGNUM_HARDWARE_DIV
      if (nb >= BITS/2)                         //   -:
      {                                         //  .
        for (;;)                                //    p2.
        {
          if (num & mask)                       //   p2 .
          {
            ph *= p1h; ph %= pmh;               //  .
          }
          if (n2 == 0) {                        //   p2.
            if ((num >>= 1) == 0) break;        //  p2 .
          } else                                //    p2.
            if ((mask <<= 1) == 0) {            //  num .
              num = *p2++; mask = 1; --n2;      //   p2.
            }
          p1h *= p1h; p1h %= pmh;               //   .
        }                                       //     p2.
      }
      else if (nb >= _CBNL_HARDDIV_BITS)        //   
      {                                         //   .
        unsigned CBNL pm = pmh;                 //   .
        pmh <<= (nb - 1);                       //   
        assert (cLongBits (pmh) == BITS-1);     //  .
        nb = nb + nb - 1;                       //   .
        for (;;)                                //    p2.
        {
          if (num & mask)                       //   p2 .
          {                                     //  .
            unsigned CBNL pp;                   //    .
            ph = _umuldCBNL (p1h, ph, &pp);     //  .
            unsigned CBNL pl = ph << nb;        //   .
            ph = _ushldCBNL (ph, pp, nb);       //   .
            unsigned CBNC nbb = nb - BITS;      //   .
            do
            {                                   //  :
              CBNL pnh = ph - pmh;              //    
              if (pnh >= 0) ph = pnh;           // ,  .
              ph = _ushld1CBNL (pl, ph);        //  ,  
              pl += pl;                         //    BITS.
            }
            while (++nbb);
            ph %= pm;                           //  .
          }
          if (n2 == 0) {                        //   p2.
            if ((num >>= 1) == 0) break;        //  p2 .
          } else                                //    p2.
            if ((mask <<= 1) == 0) {            //  num .
              num = *p2++; mask = 1; --n2;      //   p2.
            }
          {
            unsigned CBNL pp;                   //    .
            p1h = _umuldCBNL (p1h, p1h, &pp);   //  .
            unsigned CBNL p1l = p1h << nb;      //   .
            p1h = _ushldCBNL (p1h, pp, nb);     //   .
            unsigned CBNC nbb = nb - BITS;      //   .
            do
            {                                   //  :
              CBNL pnh = p1h - pmh;             //    
              if (pnh >= 0) p1h = pnh;          // ,  .
              p1h = _ushld1CBNL (p1l, p1h);     //  ,  
              p1l += p1l;                       //    BITS.
            }
            while (++nbb);
            p1h %= pm;                          //  .
          }
        }                                       //     p2.
      }
      else                                      //   .
#endif//_CBIGNUM_HARDWARE_DIV
      {
        for (;;)                                //    p2.
        {
          if (num & mask)                       //   p2 .
          {                                     //  .
            unsigned CBNL pp;                   //    .
            ph = _umuldCBNL (p1h, ph, &pp);     //  .
            unsigned CBNL pl = ph << nb;        //   .
            ph = _ushldCBNL (ph, pp, nb);       //   .
            unsigned CBNC nbb = nb - BITS - 1;  //   .
            for (;;)
            {                                   //  :
              CBNL pnh = ph - pmh;              //    
              if (pnh >= 0) ph = pnh;           // ,  .
              if (!++nbb) break;
              ph = _ushld1CBNL (pl, ph);        //  ,  
              pl += pl;                         //    BITS.
            }
          }
          if (n2 == 0) {                        //   p2.
            if ((num >>= 1) == 0) break;        //  p2 .
          } else                                //    p2.
            if ((mask <<= 1) == 0) {            //  num .
              num = *p2++; mask = 1; --n2;      //   p2.
            }
          {
            unsigned CBNL pp;                   //    .
            p1h = _umuldCBNL (p1h, p1h, &pp);   //  .
            unsigned CBNL p1l = p1h << nb;      //   .
            p1h = _ushldCBNL (p1h, pp, nb);     //   .
            unsigned CBNC nbb = nb - BITS - 1;  //   .
            for (;;)
            {                                   //  :
              CBNL pnh = p1h - pmh;             //    
              if (pnh >= 0) p1h = pnh;          // ,  .
              if (!++nbb) break;
              p1h = _ushld1CBNL (p1l, p1h);     //  ,  
              p1l += p1l;                       //    BITS.
            }
          }
        }                                       //     p2.
      }
#endif//_umoddCBNL
    }
    assert (ph < pmh);                          // .
    p [1] = ph;                                 // .
  }
#endif//_CBIGNUM_SMALL_POWMOD
}

//================================================
//         .
//================================================

//          
//           .
//         > CBNL_MAX  cBigNumberERange().
//
//         .
//            .

void    cBigNumberMRmSqrt (                     //  .
                        EXPTR(CBNL) p1,         // ,  .
                        EXPTR(CBNL) p           //   *p1/2 + 2.
        )                                       // p1, p   .
{
  assert (cBigNumberIsFit (p1));                //  .
  assert (p1 != p);                             //  .
  size_t n1 = (size_t)(*p1);                    //  .
  assert (p1 [n1] >= 0);                        //  .

  cBigTemp cBigBuf2;                            //   .
  cBigBuf2.checkexpand (n1 + 1);                // +1   .
  EXPTR(CBNL) pp2 = EXPTRTYPE(cBigBuf2);        //   .
  *pp2 = 0;                                     // .
  cBigNumberFitTo (pp2, n1);                    // .
#ifndef _CBIGNUM_MT
  _cBigNumberSkip = 1;                          //   0-.
#endif//_CBIGNUM_MT

//      .

  CBNL nbit = (cBigNumberBits (p1) + 1) & ~1;
  if ((nbit -= 2) >= 0)
  {

//         .

    {
      size_t nw = (size_t)(nbit / BITS);        // .
      CBNL lw = (((CBNL)1) << (nbit % BITS));   // .
      pp2 [nw + 1] += lw;                       //  .
      assert (pp2 [(size_t)(*pp2)] >= 0);       //  .
      p1  [nw + 1] -= lw;                       //   .
      assert (p1  [(size_t)(*p1)]  >= 0);       //  .
    }

//         .
//           ,  
//          .

    while ((nbit -= 2) >= 0)                    //    .
    {
      size_t nw = (size_t)(nbit / BITS);        // .
      CBNL lw = (((CBNL)1) << (nbit % BITS));   // .
      pp2 [nw + 1] += lw;                       //  .
      if (cBigNumberComp (p1, pp2) < 0)         // .
      {
        pp2 [nw] = (CBNL)(n1 - nw);             //   0-.
        pp2 [nw + 1] -= lw;                     //  .
        cBigNumberMDiv2D (pp2 + nw);            //    .
      }
      else
      {
        pp2 [nw] = (CBNL)(n1 - nw);             //   0-.
        cBigNumberMSubD (p1, pp2 + nw, nw);     //  .
        assert (p1 [(size_t)(*p1)] >= 0);       //  .
        assert (cBigNumberIsFit (p1));          //  .
        pp2 [nw + 1] -= lw;                     //  .
        cBigNumberMDiv2D (pp2 + nw);            //    .
        pp2 [nw + 1] += lw;                     //  .
      }
      n1 = (size_t)(pp2 [nw] + nw);             //  
      pp2 [nw] = 0;                             //   
      pp2 [0] = (CBNL)n1;                       //   0-.
      assert (pp2 [(size_t)(*pp2)] >= 0);       //  .
      assert (cBigNumberIsFit (pp2));           //  .
    }
  }

  cBigNumberFit (pp2);                          //  .
  cBigNumberCopy (pp2, p);                      //  .

//      ,      ,
//           .

  assert (cBigNumberComp ((cBigNumberMMul2M (pp2), pp2), p1) >= 0);
}

//================================================
//        .
//================================================

//         , 
//           
//        0..ULONG_MAX.
//
//           
//             .

void    cBigNumberRandom (                      //  .
                unsigned long (*pfnRand)(),     //   .
                unsigned CBNL lBits,            //   .
                        EXPTR(CBNL) p           //   lBits/BITS+1.
        )
{
  CBNL   l1 = lBits % BITS;                     //  .
  size_t n1 = (size_t)(lBits / BITS + 1);       //  .

  if (l1 != 0) l1 = cLongRandom (*pfnRand) &
                    (~(unsigned CBNL)0 >> (BITS-(size_t)l1));
  p [0] = (CBNL)n1;                             //  .
  p [n1] = l1;                                  //  .
  while (--n1 != 0) p [n1] = cLongRandom (*pfnRand);
                                                //  .
  cBigNumberFit (p);                            // .
  assert (p [(size_t)(*p)] >= 0);               //  .
}

#ifdef  NCHECKPTR
#ifdef  __cplusplus
}
#endif//__cplusplus
#endif//NCHECKPTR

#endif//_CBIGNUMF_INL
